(*
        SpaceSweeper helper 
        Loaded game.dat management service

        Author: Piotr Skowronek, pskowronek@adfinem.net
        Written in: 1997
        Licence: LGPL
 *)

Unit DATSERV;      { Dostosowany do GRY - Space Sweeper }
{$I-,R-,G+,S-,D+,Q-,V-,B-}
interface          { DAT service }
uses DOS,STRINGS;

Type
     bufor  = array [1..$FFFF] of byte;           { Do wczytywania BMP }
     paleta = array [1..256] of record r,g,b : byte; end;  { Na palet }
     dword = longint;
     BMP_File_Hdr_Type = record                      { *** BMP Header *** }
                           bfType    : word;         { 'BM' }
                           bfSize    : dword;        { Wiel caego BMP }
                           bfReserve1,
                           bfReserve2: word;
                           bfOFFBits : dword;        { Offset do danych }
                         end;
     BMP_Info_Hdr_Type = record                      {  *** BMP info ***  }
                           biSize    : dword;        { const 40 }
                           biWidth   : dword;        { Szeroko }
                           biHeight  : dword;        { Wysoko }
                           biPlanes  : word;         { Paty }
                           biBitCount: word;         { Bit na Pixel }
                           biCompression   : dword;  { 0 = w/o compresji }
                           biSizeImage     : dword;  { Wiel danych }
                           biXPelsPerMeter : dword;
                           biYPelsPerMeter : dword;
                           biClrUsed       : dword;
                           biClrImportant  : dword;
                         end;

     P_BMP_Sprite = ^T_BMP_Sprite;
     T_BMP_Sprite = record
                          xmax,
                          ymax : word;        { Max X i Max Y BitMap'y }
                          size : word;   { Ilo przydzielonej pamici }
                          pal_exist : boolean;     { Czy paleta jest ? }
                          pal  : ^paleta;   { IF Thus to wsk do palety }
                          data : ^bufor;          { Wskanik do danych }
                    end;

(************* PAK header ***************)
     P_Header    = ^T_Header;
     T_Header    = record
                         ID           : array[1..30] of char;
                   end;

     T_Fire      = record
                         x1,y1,x2,y2 : word;
                         Able        : boolean;
                         Aim         : boolean;
                         Power       : word;
                   end;

     P_Image     = ^T_Image;
     T_Image     = record
                        img    : T_BMP_Sprite;
                        Next   : P_Image;
                   end;

     P_Images    = ^T_Images;
     T_Images    = record
                         Score   : word;       { Score for shot-down }
                         Defense : word;       { How many shots to kill }
                         Bonus   : word;       { If killed then bonus ? =0 no }
                         Fire    : T_Fire;     { Fire info (pos) }
                         Image   : P_Image;    { Pointer to frames }
                         Next    : P_Images;   { Pointer to next image }
                   end;

     P_Kit       = ^T_Kit;
     T_Kit       = record
                         Alians   : P_Images;
                         Explodes : P_Images;
                         Fighters : P_Images;
                         Cockpit  : P_Images;
                         Scene    : P_Images;
                         Colors   : P_Images;
                         Next     : P_Kit;
                   end;

(********************************************************************)
     P_Resource  = ^T_Resource;
     T_Resource  = record
                         Head     : T_Header;
                         ImageKit : P_Kit;
                         Episodes : Pointer;
                   end;
(********************************************************************)

     P_Explode   = ^T_Explode;
     T_Explode   = record                     { Explode na gwiazdy }
                        xpos,ypos : integer;     { Pocztkowa pozycja wybuchu }
                        add,accel : word;        { Add - przemieszczenie }
                        TheEnd    : byte;        { Ile jeszcze gwiazd w locie }
                        explode   : array[1..50] of
                                         record
                                             kat,odl : word;
                                             max     : byte;  { Max odl }
                                         end;
                   end;


     P_Intro     = ^T_Intro;
     T_Intro     = record
                         size     : word;
                         Text     : ^bufor;
                         Image    : P_Image;
                   end;

     T_Fly_Case  = record
                         sinx   : integer;
                         siny   : integer;
                         horiz  : integer;
                         vert   : integer;
                         clip   : boolean;
                         defense: word;       { How many shots to kill }
                         which  : word;       { Ktra BitMapa w KIT }
                         point  : p_images;   { Ust. w grze bezp dost. /\ }
                   end;

     T_Crash_Case = record       { Na wypadek katastrofy corobi }
                         How    : (stars,stars_image,image,nothing);
                         Explode     : p_explode;  { Przy wybuchu ustawiany }
                         which       : word;       { If si rozwali to jak wybuch }
                         point       : p_images;   { Ust. w grze bezp dost. }
                    end;

     P_ShipsPos  = ^T_ShipsPos;
     T_ShipsPos  = record        { w sumie ok. 30B na jeden statek }
                         What        : (flying,dieing,dead);
                         x,y         : word;       { Ostatnia pozycja }
                         Fly_Case    : T_Fly_Case; { Jak si ma porusza }
                         Crash_Case  : T_Crash_Case; { How to explode }
                         FireAble    : boolean;    { czy ma strzela }
                         Bonus       : word;       { =0 no bonus }
                         frame,delay : byte;       { do animacji (opnienie) }
                         Next        : P_ShipsPos; { Next Alian }
                   end;

     P_Levels    = ^T_Levels;
     T_Levels    = record         { level'e }
                         ShipsPos : P_ShipsPos;    { "tablica" pos statkw }
                         WhichKit : word;          { Ktry zestaw img'w }
                         MaxPos   : word;          { Dugo drogi }
                         Intro    : P_Intro;       { Wprowadzenie }
                         Title    : string[50];    { Tytu level'a }
                         Next     : P_Levels;      { Nastpny level }
                   end;

(*********************************************************************)
     P_Episodes  = ^T_Episodes;
     T_Episodes  = record         { Episody z level'ami }
                         Levels   : P_Levels;      { Grupa leveli }
                         Intro    : P_Intro;       { Wprow. do episodu }
                         Title    : string[50];    { Tytu episodu }
                         Skill    : array [1..3] of string[50]; { Nazwy poziomw trudnoci }
                         Next     : P_Episodes;    { Next episode }
                   end;
(*********************************************************************)


var  Black,Blue,Green,Cyan,Red,Magenta,Brown,LightGray, { kolory }
     DarkGray,LightBlue,LightGreen,LightCyan,LightRed,
     LightMagenta,Yellow,White,TxtCol_1st,TxtCol_2nd  :  byte;


(**** Pomocnicze ****)
function  StrCmp(fir,sec: pchar): boolean;     { Porwnywanie string'w }
Function  Reserve_Mem(size: word): pointer;    { Alokacja miejsca w pamici }
procedure Check4Error(name: string);           { Sprawdza na obecno bdw }
function  ErrorName(err: integer): PChar;

(**** Zapis DATw ***)
procedure InitResourceFile(name: string);      { Tworzy nowy z nagwkiem }
procedure AddKit(name: string; pos: longint);  { Dodaje nastpny KIT }
function  WriteBranches(name: string; Kit: T_kit): longint;
function  NewArmed(score: word; x1,y1,x2,y2: word; FireAim: boolean; what,next: pointer): pointer;
function  NewBranch(score: word; what,next: pointer): pointer;
function  NewShip(name: string;ReadPal: Boolean; next: pointer): pointer;

procedure WriteEpisodes(name: string; Epi: P_Episodes);

(*** Odczyt DATw ***)
procedure ReadKit(name: string; which_kit: byte; var Kit : P_Kit);
procedure DisposeKit(var Kit: P_Kit);      { Zwalnia pami KITa }
procedure DelBranche(var pos: p_images);   { Zwalnia tylko odnog }

function  ReadLevel(name: string; which_epi, which_lev: word): pointer;
function  ReadEpisode(name: string; which_epi: word): pointer;
function  ReadIntro(name: string; which_epi,which_lev: word): p_intro;
procedure DisposeIntro(var p_int: p_intro);     { Zwalnia pami dla intra }
procedure DisposeLevel(var P_Lev: P_Levels);    { Zwalnia pami level'owi }

function  ReadSprite(name: string; pos: longint): p_bmp_sprite;

function  GetMaxKits(name: string): word;       { Ilo zestaww }
function  GetMaxEpisodes(name: string): word;   { Ilo Episodw }
function  GetMaxLevels(name: string; which_epi: word): word;  { Ilo Leveli }
function  GetMaxShips(P_Lev: P_Levels): word;   { Ilo statkw w level'u }
function  GetMaxSprite(P_Ima: P_Images): word;  { Ilo odp sprite'w w KIT }
function  GetMaxFrame(P_Ima: P_Images; which_sprite: word): word;
function  GetFrame(P_Ima: P_Images; which_sprite, which_frame: word): P_BMP_Sprite;
function  GetShipPos(Epi: P_Episodes; which_epi,which_lev,which_shi: word): P_ShipsPos;
function  LastShipPos(Epi: P_Episodes; var which_epi,which_lev: word): P_ShipsPos;
procedure DisposeShipPos(Epi: P_Episodes; which_epi,which_lev,which_shi: word); { Zwalnia pami statkowi }

procedure SetColors(Kit: P_Kit);           { Ust. palet i numery 16 kolorom }
implementation


const Yes = True;
      No  = False;
      ID  : PChar = 'Space Sweeper''s data file !';



(****** Pomocnicze ******)
procedure txt_mode; assembler;
asm
        mov     ah,0fh
        int     10h
        cmp     al,03h
        jz      @Juz_w_textowym

        mov     ax,0003h
        int     10h

@Juz_w_textowym:
end;

function ErrorName(err: integer): PChar;
begin
     case err of
        0 : ErrorName:='';
        2 : ErrorName:='File not found.';
        3 : ErrorName:='Path not found.';
        4 : ErrorName:='Too many open files.';
        5 : ErrorName:='File access denied.';
      100 : ErrorName:='Disk read error.';
      101 : ErrorName:='Disk write error.';
      106 : ErrorName:='Invalid numeric format.';
      150 : ErrorName:='Disk is write protected.';
      152 : ErrorName:='Disk not ready.';
      162 : ErrorName:='Hardware error.';
      200 : ErrorName:='Division by zero.';
      201 : ErrorName:='Range check error.';
      202 : ErrorName:='Stack overflow error.';
      203 : ErrorName:='Heap overflow (not enough memo?).';
      204 : ErrorName:='Invalid pointer operation.';
      255 : ErrorName:='[!] Ctrl-Break pressed [!] (What for?)';
       Else ErrorName:='Unanticipated error. Report kindly requested.';
     end;

end;

procedure Check4Error(name: string);
var  Blad : Integer;
begin
     Blad:=IOResult;
     IF Blad=0 Then Exit;
     txt_mode;
     Writeln('FATAL: Was an error while accessing resource file.');
     Write  ('       Name of file is: <',name,'>');
     if blad in [2,3] then            { File/path not found }
     Writeln(', check for his existing.  ');
     Writeln('       ERR[',blad,']: ',ErrorName(blad));
     Writeln('PROGRAM HALTED');
     Halt;
end;

procedure WriteExitMsg(name: string);
begin
     txt_mode;
     writeln('Error:  ',name);
     writeln('PROGRAM HALTED');
     halt;
end;


Function reserve_mem(size: word): pointer;      { Alokacja miejsca w pamici }
var  P: Pointer;
begin
     IF MaxAvail<Size Then
        begin
             writeln('FATAL: Not enough memo to continue program.');
             writeln('       Free about over ',Size-MaxAvail,' bytes and try again.');
             writeln('           --- PROGRAM HALTED ---');
             halt;
        end;
     GetMem(P,size);
     Reserve_Mem:=P;
end;

function GetFName(var F: file): string;
var  i: byte;
     s: string[90];
begin
     s:='';
     for i:=1 to 255 do
         if mem[seg(f):ofs(f)+47+i]=0 then begin s[0]:=chr(i-1); break; end
         else
         s[i]:=chr(mem[seg(f):ofs(f)+47+i]);
     GetFName:=s;
end;

function StrCmp(fir,sec: pchar): boolean;
var  i: word;
begin
     For i:=0 to $FFFF do
         begin
              if (fir[i]=#0) and (sec[i]=#0) Then begin StrCmp:=True; exit end;
              if (fir[i]<>sec[i]) Then begin StrCmp:=False; exit end;
         end;
end;

procedure setrgbpal(s,o:word); assembler;       { Set RGB palete colorow }
asm                                             { Proc zapisu palety RGB  }
        push    ds
        mov     ds,ss:s
        mov     si,ss:o

        mov     cx,256*3
        mov     dx,3c8h
        xor     al,al
        out     dx,al
        inc     dx
        cld
@petel:
        outsb
        loop    @petel
        pop     ds
end;

procedure FreeM(p: pointer; size: word);
begin
     if p<>nil Then FreeMem(p,size);
end;





(****************************** Odczyt BMP'w *******************************)
procedure Read_Sprite(path: string; var BMP_Sprite: T_BMP_Sprite; ReadPal: Boolean);
Type
    tab = array [1..256] of record
                                  r,g,b,nic : byte;
                            end;
Var i          : word;
    bmp        : file;
    BMPFileHdr : ^BMP_File_Hdr_Type;
    BMPInfoHdr : ^BMP_Info_Hdr_Type;
    Tym        : ^tab;
    Head       : dword;
    Xmax,Ymax  : integer;
    P          : pointer;
begin
FileMode:=0;
assign(bmp,path);
reset(bmp,1);
Check4Error(path);

BMPFileHdr:=Reserve_Mem(SizeOf(BMP_File_Hdr_Type));
BMPInfoHdr:=Reserve_Mem(SizeOf(BMP_Info_Hdr_Type));
BlockRead(bmp,BMPFileHdr^,SizeOf(BMP_File_Hdr_Type));
BlockRead(bmp,BMPInfoHdr^,SizeOf(BMP_Info_Hdr_Type));
IF (BMPFileHdr^.bfType<>256*77+66) or (BMPInfoHdr^.biPlanes<>1) or
   (BMPInfoHdr^.biBitCount<>8) or (BMPInfoHdr^.biCompression<>0) Then
   WriteExitMsg('FATAL: Unsupported BMP file.'+#10+#13+
                '       File name: ['+path+'].');
Xmax:=BMPinfoHdr^.biWidth;
Ymax:=BMPInfoHdr^.biHeight;
Head:=BMPFileHdr^.bfOffBits;
If xmax mod 4<>0 then xmax:=(trunc(xmax/4))*4+4;
FreeMem(BMPFileHdr,SizeOf(BMP_File_Hdr_Type));
FreeMem(BMPInfoHdr,SizeOf(BMP_Info_Hdr_Type));

IF ReadPal Then
begin
Tym:=Reserve_Mem(SizeOf(tab));
BMP_Sprite.Pal:=Reserve_Mem(SizeOf(paleta));
seek(bmp,$36);
BlockRead(bmp,Tym^,sizeof(Tab));               { Get Palette from BMP }
for i:=1 to 256 do
    begin
         BMP_Sprite.Pal^[i].R:=Tym^[i].B shr 2;
         BMP_Sprite.Pal^[i].G:=Tym^[i].G shr 2;
         BMP_Sprite.Pal^[i].B:=Tym^[i].R shr 2;
    end;
FreeMem(Tym,SizeOf(tab));
BMP_Sprite.Pal_Exist:=True;
end else
BMP_Sprite.Pal_Exist:=False;


BMP_Sprite.Data:=Reserve_Mem(FileSize(BMP)-head);

Seek(BMP,Head);
BlockRead(BMP,BMP_Sprite.Data^,FileSize(BMP)-Head);
BMP_Sprite.Xmax:=Xmax;
BMP_Sprite.Ymax:=Ymax;
BMP_Sprite.Size:=FileSize(BMP)-head;

close(bmp);
end;


function NewShip(name: string;ReadPal: Boolean; next: pointer): pointer;
var  p: P_Image;
begin
     New(p);
     Write('Reading: ',name:12);
     Read_Sprite(name, p^.img, ReadPal);
     Writeln(' -> ',p^.img.xmax,'x',p^.img.ymax);
     p^.next:=next;
     NewShip:=p;
end;


function NewBranch(score: word; what,next: pointer): pointer;
var  p: P_Images;
begin
     New(p);
     p^.score:=score;
     p^.image:=what;
     p^.next:=next;
     NewBranch:=p;
end;


function NewArmed(score: word; x1,y1,x2,y2: word; FireAim: boolean; what,next: pointer): pointer;
var  p: P_Images;
begin
     New(p);
     p^.score:=score;
     p^.Fire.x1:=x1;
     p^.Fire.y1:=y1;
     p^.Fire.x2:=x2;
     p^.Fire.y2:=y2;
     p^.Fire.Able:=Yes;
     p^.Fire.Aim:=FireAim;
     p^.Fire.Power:=1;
     p^.image:=what;
     p^.next:=next;
     NewArmed:=p;
end;


procedure InitResourceFile(name: string);  {  Utworzenie pliku z nagwkiem }
var  f     : file;
     t_res : T_resource;
begin
     Assign(f,name);
     rewrite(f,1);
     StrCopy(@T_res.Head.ID,ID);
     T_Res.ImageKit:=nil;
     T_Res.Episodes:=nil;
     Blockwrite(f,T_res,sizeof(t_res));
     close(f);
end;

procedure AddKit(name: string; pos: longint);
var  head : T_resource;
     kit  : T_kit;
     f    : file;
begin
     Assign(f,name);
     reset(f,1);
     blockread(f,head,sizeof(head));
     seek(f,longint(head.imagekit));
     if head.imagekit=nil then
        begin
             seek(f,0);
             head.imagekit:=pointer(pos);
             blockwrite(f,head,sizeof(head));
        end else
     repeat
           blockread(f,kit,sizeof(kit));
           Check4Error(name);
           if kit.next=nil Then
              begin
                   kit.next:=pointer(pos);
                   seek(f,filepos(f)-sizeof(kit));
                   blockwrite(f,kit,sizeof(kit));
                   break;
              end;
           seek(f,longint(kit.next));
     until false;
     close(f);
end;


function WriteBranches(name: string; Kit: T_Kit): longint;

function NoOfBranches(p: p_images): word;
var  count : word;
begin
     count:=1;
     repeat
          If p^.next=nil Then break
                         Else begin p:=p^.next; inc(count); end;
     until false;
     NoOfBranches:=count;
end;

procedure write_tab(p: p_images; var F: file);
type t_tmp  = record
                    fpos      : longint;
                    p_branche : p_images;
                    t_branche : t_images;
                    p_sub     : p_image;
                    t_sub     : t_image;
                    p_bmp     : p_bmp_sprite;
                    t_bmp     : t_bmp_sprite;
              end;
const datbeg : pchar = 'DATA ->';
      datend : pchar = '<- DATA';
      palbeg : pchar = 'PAL ->';
      palend : pchar = '<- PAL';
var
     i,j     : word;
     temp1   : t_tmp;
     temp2   : t_tmp;
     temp3   : t_tmp;
     tympos1 : longint;
     tympos2 : longint;
     p2      : p_image;

begin
     repeat
          temp1.fpos:=FilePos(F);          { Rozdzielenie }
          temp1.t_branche:=p^;
          temp1.p_branche:=p;

          p2:=p^.image;
          seek(f,FilePos(f)+SizeOf(temp1.t_branche));

          repeat                            { Kolejne Bitmapy }
                   temp2.t_sub:=p2^;
                   temp2.p_sub:=p2;
                   temp2.fpos:=FilePos(f);
                   seek(f,FilePos(f)+SizeOf(temp2.t_sub));


                   if temp2.t_sub.img.pal_exist Then
                   begin                    { Write PAL if exists }
                   write('PAL -> ');
                   blockwrite(f,palbeg^,StrLen(palbeg)+1);   { PAL -> }
                   temp2.t_sub.img.pal:=pointer(filepos(f)); { Where in file ? }
                   blockwrite(f,temp2.p_sub^.img.pal^,3*256);{ Write PAL }
                   blockwrite(f,palend^,StrLen(palend)+1);   { <- PAL }
                   end;
                   blockwrite(f,datbeg^,StrLen(datbeg)+1);   { DATA -> }
                   temp2.t_sub.img.data:=pointer(Filepos(f));{ Where in file ? }

                                            { Ciaa Bitmap }
                   blockwrite(f,temp2.p_sub^.img.data^,temp2.t_sub.img.size);
                   blockwrite(f,datend^,StrLen(datend)+1);
                   Write(temp2.t_sub.img.size,', ');

                   tympos2:=FilePos(f);
                   If p2^.next<>nil Then temp2.t_sub.next:=pointer(FilePos(f))
                                    Else temp2.t_sub.next:=nil;
                   seek(f,temp2.fpos);
                   blockwrite(f,temp2.t_sub,sizeof(temp2.t_sub));
                   seek(f,tympos2);
                   If p2^.next=nil then break;
                   p2:=p2^.next;
          until false;
          Writeln(#8,#8,' -> END.');

          p:=p^.next;
          tympos1:=FilePos(f);              { Zapisanie pos w pliku do NEXT }
          if p<>nil Then temp1.t_branche.next:=pointer(tympos1)
                    else temp1.t_branche.next:=nil;
          temp1.t_branche.image:=pointer(temp1.fpos+Sizeof(temp1.t_branche));
          seek(f,temp1.fpos);
          blockwrite(f,temp1.t_branche,sizeof(temp1.t_branche));
          seek(f,tympos1);

          if p=nil then break;
     Until false;
     Writeln('File size: ',FileSize(f));
end;

var   f       : file;
      tpos    : longint;
      Tkit    : T_Kit;
begin
     filemode:=2;
     assign(f,name);
     reset(f,1);
     check4error(name);

     tpos:=FileSize(f);
     Seek(f,FileSize(f)+Sizeof(Tkit));

     Writeln('Alian''s branches: ',NoOfBranches(Kit.Alians));
     Writeln('Explode''s branches: ',NoOfBranches(Kit.Explodes));
     Writeln('Fight''s branches: ',NoOfBranches(Kit.Fighters));

     Tkit.Alians:=pointer(filepos(f));
     write_tab(Kit.Alians,F);
     Tkit.Explodes:=pointer(filesize(f));
     write_tab(Kit.Explodes,F);
     Tkit.Fighters:=pointer(filesize(f));
     write_tab(Kit.Fighters,F);
     Tkit.Cockpit:=pointer(filesize(f));
     write_tab(Kit.Cockpit,F);
     Tkit.Scene:=pointer(filesize(f));
     write_tab(Kit.Scene,F);
     Tkit.Colors:=pointer(filesize(f));
     write_tab(Kit.Colors,F);
     Tkit.Next:=nil;

     seek(f,tpos);
     blockwrite(f,tkit,SizeOf(Tkit));
     close(f);
     WriteBranches:=tpos;
end;


(****************************************************************************
 **************************  * Do odczytu DATw *  **************************
 ****************************************************************************)
procedure ReadKit(name: string; which_kit: byte; var Kit : P_Kit);
                                            { Odczytuje cay KIT do pamici }
function ReadBranche(var f: file; pos: longint): p_images;
var   p_branche : p_images;
      t_branche : t_images;
      p_sub     : p_image;
      t_sub     : t_image;
begin
     new(p_branche);
     ReadBranche:=p_branche;
     seek(f,pos);
repeat
     BlockRead(f,t_branche,SizeOf(t_images));
     p_branche^:=t_branche;
     New(p_sub);
     p_branche^.image:=p_sub;

     Seek(f,Longint(t_branche.image));       { Odczyt "Sub katalogu" }
     BlockRead(f,t_sub,SizeOf(t_sub));

     repeat
     p_sub^:=t_sub;
     If t_sub.img.pal_exist Then          { Odczyt palety jeli jest }
     begin
          seek(f,Longint(t_sub.img.pal));
          p_sub^.img.pal:=Reserve_Mem(3*256);
          BlockRead(f,p_sub^.img.pal^,3*256);
     end;

     p_sub^.img.data:=reserve_mem(t_sub.img.size);
     seek(f,Longint(t_sub.img.data));          { Odczyt ciaa bitmap }
     BlockRead(f,p_sub^.img.data^,t_sub.img.size);

     if t_sub.next=nil Then
        begin
             p_sub^.next:=nil;
             break;
        end;

     p_sub^.next:=reserve_mem(sizeof(t_image));
     p_sub:=p_sub^.next;
     Seek(f,Longint(t_sub.next));            { Odczyt "Sub katalogu" }
     BlockRead(f,t_sub,SizeOf(t_sub));

     until false;

     if t_branche.next = nil Then
        begin
             p_branche^.next:=nil;
             break;
        end;
     seek(f,longint(t_branche.next));
     p_branche^.next:=reserve_mem(sizeof(t_branche));
     p_branche:=p_branche^.next;
until false;
end;

var  Head : T_Resource;
     PKit : P_Kit;
     f    : file;
     i    : byte;
begin
     if kit=nil then New(Kit);
     filemode:=0;
     assign(f,name);
     reset(f,1);
     Check4Error(name);
     blockread(f,Head,SizeOf(Head));
     If NOT StrCmp(@Head.Head.ID,ID) Then
        WriteExitMsg('Incorrect bitmap resource. File name: '+name);
     if Head.ImageKit=nil Then
        WriteExitMsg('Images not found in resource.');
     PKit:=Head.ImageKit;
     for i:=1 to which_kit do
     begin
          seek(f,Longint(Pkit));
          blockread(f,kit^,sizeof(T_Kit));
          if kit^.Next = nil then break;
          pkit:=kit^.next;
     end;
     Kit^.Alians:=ReadBranche(f,Longint(Kit^.Alians));
     Kit^.Explodes:=ReadBranche(f,Longint(Kit^.Explodes));
     Kit^.Fighters:=ReadBranche(f,Longint(Kit^.Fighters));
     Kit^.Cockpit:=ReadBranche(f,Longint(Kit^.Cockpit));
     Kit^.Scene:=ReadBranche(f,Longint(Kit^.Scene));
     Kit^.Colors:=ReadBranche(f,Longint(Kit^.Colors));
     close(f);
end;


procedure DelBranche(var pos: p_images);       { Wymazuje tylko jedn ga }
var   p_branche : p_images;
      p_sub     : p_image;
      p_next    : p_image;
begin
repeat
     p_sub:=pos^.image;
     p_branche:=pos^.next;
     if pos=nil then exit;
     dispose(pos);
     if p_sub<> nil then
     repeat
           p_next:=p_sub^.next;
           If p_sub^.img.pal_exist Then FreeM(p_sub^.img.pal,3*256);
           FreeM(p_sub^.img.data,p_sub^.img.size);
           dispose(p_sub);
           if p_next = nil then break;
           p_sub:=p_next;
     until false;

     pos:=p_branche;
     if pos = nil then break;
until false;
     pos:=nil;
end;

procedure DisposeKit(var Kit : P_Kit);    { Zwalnia ca pami dla zestawu }
begin
     DelBranche(Kit^.Alians);
     DelBranche(Kit^.Explodes);
     DelBranche(Kit^.Fighters);
     DelBranche(Kit^.Cockpit);
     DelBranche(Kit^.Scene);
     DelBranche(Kit^.Colors);
end;



procedure SetColors(Kit : P_Kit); { Ustawia palet i odpowiednie kolory }
var  pos: word;
begin
     pos:=Kit^.Colors^.image^.img.size-Kit^.Colors^.image^.img.xmax;
     Black:=Kit^.Colors^.image^.img.data^[pos+1];
     Blue:=Kit^.Colors^.image^.img.data^[pos+2];
     Green:=Kit^.Colors^.image^.img.data^[pos+3];
     Cyan:=Kit^.Colors^.image^.img.data^[pos+4];
     Red:=Kit^.Colors^.image^.img.data^[pos+5];
     Magenta:=Kit^.Colors^.image^.img.data^[pos+6];
     Brown:=Kit^.Colors^.image^.img.data^[pos+7];
     LightGray:=Kit^.Colors^.image^.img.data^[pos+8];
     DarkGray:=Kit^.Colors^.image^.img.data^[pos+9];
     LightBlue:=Kit^.Colors^.image^.img.data^[pos+10];
     LightGreen:=Kit^.Colors^.image^.img.data^[pos+11];
     LightCyan:=Kit^.Colors^.image^.img.data^[pos+12];
     LightRed:=Kit^.Colors^.image^.img.data^[pos+13];
     LightMagenta:=Kit^.Colors^.image^.img.data^[pos+14];
     Yellow:=Kit^.Colors^.image^.img.data^[pos+15];
     White:=Kit^.Colors^.image^.img.data^[pos+16];

     TxtCol_1st:=LightRed;
     TxtCol_2nd:=Red;

     IF NOT Kit^.Colors^.Image^.Img.Pal_Exist Then
        WriteExitMsg('Palette not found in resource.');

     SetRGBpal(Seg(Kit^.Colors^.Image^.Img.pal^),
               Ofs(Kit^.Colors^.Image^.Img.pal^));
end;


(****************** Write Episodes *******************)
procedure WriteEpisodes(name: string; Epi: P_Episodes);
function WriteIntro(var f: file; P: P_intro): pointer;
const datbeg : pchar = 'INTRO >>';
      datend : pchar = '<< INTRO';

var  T_Int   : T_Intro;
     P_Int   : P_Intro;
     T_Img   : T_Image;
     P_Img   : P_Image;
     TymPos1 : longint;
     TymPos2 : longint;

begin
     if P = nil then exit;

     P_Int:=P;                    { Intro }
     seek(f,filesize(f));
     blockwrite(f,datbeg^,StrLen(datbeg)+1);  { Begin of INTRO info }
     WriteIntro:=Pointer(filepos(f));
     TymPos2:=FilePos(f);
     Seek(f,filepos(F)+Sizeof(T_Int));

     T_Int:=P_Int^;
     T_Int.Text:=Pointer(FilePos(f));       { Text }
     blockwrite(f,P_Int^.Text^,P_Int^.Size);
     P_Img:=T_Int.Image;                    { Image }
     T_Int.Image:=Pointer(FilePos(f));
     T_Img:=P_Img^;
     T_Img.Next:=nil;                     { Zalepianie (moe kiedy nie ?) }
     TymPos1:=FilePos(f);
     seek(f,FilePos(f)+sizeof(T_img));

     T_Img.img.Pal:=Pointer(Filepos(f));
     if T_Img.img.Pal_Exist Then
     BlockWrite(f,P_Img^.img.Pal^,3*256);
     T_Img.img.Data:=Pointer(Filepos(f));
     BlockWrite(f,P_Img^.img.Data^,P_Img^.img.Size);  { ciao BitMapy }

     blockwrite(f,datend^,StrLen(datend)+1);  { End of INTRO info }

     Seek(f,TymPos1);
     blockwrite(f,T_Img,Sizeof(T_img));     { Image }

     seek(f,TymPos2);                       { Intro }
     blockwrite(f,T_Int,SizeOf(T_int));

end;

var  f       : file;
     head    : T_Resource;
     T_Epi   : T_Episodes;
     P_Epi   : P_Episodes;
     T_Shi   : T_ShipsPos;
     P_Shi   : P_ShipsPos;
     T_Lev   : T_Levels;
     P_Lev   : P_Levels;
     tym1    : longint;
     tym2    : longint;
     Nextpos : longint;
     TymPos1 : longint;
     TymPos2 : longint;

begin
     filemode:=2;
     assign(f,name);
     reset(f,1);
     check4error(name);
     blockread(f,head,sizeof(head));
     check4error(name);
     if head.episodes<> nil Then WriteExitMsg('Resource already have an episodes.');
     head.episodes:=pointer(filesize(f));
     seek(f,0);
     blockwrite(f,head,sizeof(head));

     P_Epi:=Epi;
     seek(f,filesize(f));
repeat
     T_Epi:=P_Epi^;
     tym1:=filepos(f);                      { Episode }
     Seek(f,filepos(f)+sizeof(T_Episodes));

     P_Lev:=T_Epi.Levels;
     T_Epi.Levels:=Pointer(filepos(f));
  repeat
     if P_Lev=nil then WriteExitMsg('Level pointer is null');
     T_Lev:=P_Lev^;
     tym2:=filepos(f);                      { Level }
     Seek(f,filepos(f)+sizeof(T_Levels));

     P_Shi:=T_Lev.ShipsPos;
     T_Lev.ShipsPos:=pointer(FilePos(f));
     repeat;
            T_Shi:=P_Shi^;
            T_Shi.Next:=pointer(filesize(f));
            blockwrite(f,T_Shi,SizeOf(T_Shi));
            if P_Shi^.Next = nil Then break;
            P_Shi:=P_Shi^.Next;
     until false;

     T_Lev.Intro:=WriteIntro(f,T_Lev.Intro);
     if P_Lev^.Next<>nil then T_Lev.Next:=Pointer(FileSize(f));   { Next }

     seek(f,tym2);                          { Level }
     blockwrite(f,T_Lev,sizeof(T_Lev));
     seek(f,NextPos);
     P_Lev:=P_Lev^.Next;
     if P_Lev = nil then break;
  until false;


     T_Epi.Intro:=WriteIntro(f,T_Epi.Intro);


     if P_Epi^.Next<>nil then T_Epi.Next:=pointer(FileSize(f));

     NextPos:=FilePos(f);
     seek(f,tym1);                          { Episode }
     blockwrite(f,T_Epi,sizeof(T_Episodes));
     P_Epi:=P_Epi^.Next;
     seek(f,NextPos);
     if P_Epi=nil Then break;
until false;
     close(f);
end;



(****************** R E A D I N G ********************)
procedure OpenResource(var f: file; name: string);
begin                             { Open for reading }
     filemode:=0;
     assign(f,name);
     reset(f,1);
     Check4Error(name);
end;

procedure ReadResourceHeader(var f: file; head: p_resource);
begin
     if head=nil then WriteExitMsg('Null assignment.');
     blockread(f,head^,sizeof(T_resource));
     Check4Error(GetFName(f));
end;

function SeekEpisode(var f: file; pos: longint; which_epi: word; Epi: P_Episodes): word;
var  i : word;
begin
     seek(f,pos);
     for i:=1 to which_epi do
     begin
          SeekEpisode:=i;
          blockread(f,Epi^,SizeOf(T_Episodes));
          Check4Error(GetFName(f));
          if i = which_epi then break;
          seek(f,longint(Epi^.Next));
          if Epi^.Next = nil then break;
     end;
end;

function SeekLevel(var f: file; pos: longint; which_lev: word; Lev: P_Levels): word;
var  i: word;
begin
     seek(f,pos);
for i:=1 to which_lev do
begin
     SeekLevel:=i;
     blockread(f,Lev^,Sizeof(T_Levels));
     Check4Error(GetFName(f));
     if i = which_lev then break;
     if Lev^.Next = nil then break;
     seek(f,longint(Lev^.Next));
end;
end;



(******************** R E A D I N G *******************)
function  GetMaxKits(name: string): word;
var  head  : T_Resource;
     kit   : T_Kit;
     p     : P_Kit;
     f     : file;
     count : word;
begin
     OpenResource(f,name);
     ReadResourceHeader(f,@head);
     count:=0;

     if head.Imagekit = nil then WriteExitMsg('Image kit not found.');
     p:=head.ImageKit;
repeat
     inc(count);
     seek(f,longint(p));
     blockread(f,kit,sizeof(kit));
     check4error(name);
     if kit.next = nil then break;
     p:=kit.next;
until false;

     GetMaxKits:=count;
     close(F);
end;


function GetMaxEpisodes(name: string): word;
var  head  : T_Resource;
     Epi   : T_Episodes;
     f     : file;
begin
     OpenResource(f,name);
     ReadResourceHeader(f,@head);

     if head.episodes = nil then
        begin GetMaxEpisodes:=0; close(f); exit; end;

     GetMaxEpisodes:=SeekEpisode(f,longint(head.Episodes),$FFFF,@Epi);
     close(F);
end;


function GetMaxLevels(name: string; which_epi: word): word;
var  head  : T_Resource;
     Epi   : T_Episodes;
     Lev   : T_Levels;
     f     : file;
begin
     OpenResource(f,name);
     ReadResourceHeader(f,@head);

     if head.episodes = nil then
        begin GetMaxLevels:=0; close(f); exit; end;

     SeekEpisode(f,longint(head.Episodes),which_epi,@Epi);

     if Epi.Levels = nil then WriteExitMsg('Episode does not contain levels.');

     GetMaxLevels:=SeekLevel(f,longint(Epi.Levels),$FFFF,@Lev);
     close(F);
end;


function GetMaxShips(P_Lev: P_Levels): word;
var  Count : word;
     P_Shi : P_ShipsPos;
     i     : word;
begin
     if P_Lev = nil then WriteExitMsg('Null assignment');
     count:=0;
     P_Shi:=P_Lev^.ShipsPos;
     if P_Shi = nil then WriteExitMsg('Null assignment');
repeat
     inc(count);
     if P_Shi^.Next = nil then break;
     P_Shi:=P_Shi^.Next;
until false;
     GetMaxShips:=Count;
end;

function  GetMaxSprite(P_Ima: P_Images): word;
var  i     : word;
begin
     for i:=1 to $FFFF do
     begin
          GetMaxSprite:=i;
          if P_Ima^.Next=nil then break;
          P_Ima:=P_Ima^.Next;
     end;
end;




function ReadSprite(name: string; pos: longint): p_bmp_sprite;
var  f : file;
     p : p_bmp_sprite;
begin
     filemode:=0;
     assign(f,name);
     reset(f,1);
     p:=reserve_mem(sizeof(T_BMP_Sprite));
     ReadSprite:=p;

     seek(f,pos);
     blockread(f,p^,sizeof(t_bmp_sprite));
     check4error(name);

     if p^.pal_exist then
        begin
             seek(f,longint(p^.pal));
             p^.pal:=reserve_mem(3*256);
             blockread(f,p^.pal^,3*256);
        end;

     seek(f,longint(p^.data));
     p^.data:=reserve_mem(p^.size);
     blockread(f,p^.data,p^.size);
     check4error(name);
     close(F)
end;

function ReadIntroFromDisk(name: string; pos: longint): p_intro;
var  f     : file;
     P_Int : P_Intro;
     P_Img : P_Image;

begin
     filemode:=0;
     assign(f,name);
     reset(f,1);
     Check4Error(name);

     p_int:=reserve_mem(SizeOf(T_Intro));
     ReadIntroFromDisk:=p_int;

     seek(f,pos);
     blockread(f,p_int^,sizeof(t_intro));
     if p_int^.text <> nil then       { Czy zawiera text ? }
        begin
             seek(f,longint(p_int^.text));
             p_int^.text:=reserve_mem(p_int^.size);
             blockread(f,p_int^.text^,p_int^.size);
        end;
     If p_int^.image <> nil then      { Czy zawiera image ? }
        begin
             seek(f,longint(p_int^.image));
             p_img:=reserve_mem(sizeof(T_image));
             p_int^.image:=p_img;
             blockread(f,p_img^,sizeof(T_image));
             p_img^.img:=ReadSprite(name,longint(p_img))^;
        end;
     close(f);
end;


function ReadIntro(name: string; which_epi,which_lev: word): p_intro;
              { if which_lev=0 then read episode intro }
var  f    : file;
     head : T_Resource;
     Epi  : T_Episodes;
     Lev  : T_Levels;
begin
     OpenResource(f,name);
     ReadResourceHeader(f,@head);

     if head.episodes = nil then WriteExitMsg('File: ['+name+'] does not contain episodes.');

     if SeekEpisode(f,longint(head.Episodes),which_epi,@epi)<>which_epi then
        WriteExitMsg('Episode DO NOT exist.');

     if which_lev = 0 then
        begin
             close(f);
             ReadIntro:=ReadIntroFromDisk(name,longint(Epi.Intro));
             exit;
        end;

     if SeekEpisode(f,longint(Epi.Levels),which_lev,@lev)<>which_lev then
        WriteExitMsg('Level not exist in episode.');;

     close(f);
     ReadIntro:=ReadIntroFromDisk(name,longint(Lev.intro));
end;


function ReadLevel(name: string; which_epi,which_lev: word): pointer;
var  head  : T_Resource;
     Epi   : T_Episodes;
     Lev   : T_Levels;
     P_Lev : P_Levels;
     P_Shi : P_ShipsPos;
     f     : file;

begin
     OpenResource(f,name);
     ReadResourceHeader(f,@head);

     if head.episodes = nil then WriteExitMsg('File: ['+name+'] does not contain episodes.');

     if SeekEpisode(f,longint(head.Episodes),which_epi,@epi)<>which_epi then
        WriteExitMsg('Episode DO NOT exist.');

     if Epi.Levels = nil then WriteExitMsg('Episode does not contain levels.');

     if SeekEpisode(f,longint(Epi.Levels),which_lev,@lev)<>which_lev then
        WriteExitMsg('Level not exist in episode.');;

     p_lev:=reserve_mem(sizeof(lev));
     ReadLevel:=p_lev;              { Function returns entry to level }
     p_lev^:=lev;

     p_shi:=reserve_mem(sizeof(T_ShipsPos));
     seek(f,longint(p_lev^.ShipsPos));
     if p_lev^.ShipsPos = nil then WriteExitMsg('Level DOES NOT contain ships positions.');
     p_lev^.ShipsPos:=p_shi;

repeat                              { Czyta pozycje statkw z level'a }
     blockread(f,p_shi^,sizeof(T_ShipsPos));
     Check4Error(name);

     if p_shi^.next=nil then break;
     p_shi:=p_shi^.next;
     seek(f,longint(p_shi));
     p_shi:=reserve_mem(sizeof(T_ShipsPos));
until false;

     p_lev^.intro:=nil;             { Funkcja nie aduje intra }
     close(F);
end;


function  ReadEpisode(name: string; which_epi: word): pointer;
var  head  : T_Resource;
     Epi   : T_Episodes;
     P_epi : P_Episodes;
     i     : word;
     f     : file;
begin
     OpenResource(f,name);
     ReadResourceHeader(f,@head);

     if head.episodes = nil then WriteExitMsg('File: ['+name+'] does not contain episodes.');

     if SeekEpisode(f,longint(head.Episodes),which_epi,@epi)<>which_epi then
        WriteExitMsg('Episode DO NOT exist.');

     p_epi:=reserve_mem(sizeof(T_episodes));
     p_epi^:=epi;

     p_epi^.levels:=nil;              { Czyta tylko episod-info nie levele }
     p_epi^.intro:=nil;               { Czyta tylko episod-info nie intro  }

     close(F);
end;

function  GetFrame(P_Ima: P_Images; which_sprite, which_frame: word): P_BMP_Sprite;
var  i     : word;
     P_Img : P_Image;
begin

     for i:=1 to which_sprite do
     begin
          if i=which_sprite then break;
          if P_Ima^.Next=nil then WriteExitMsg('Sprite not found.');
          P_Ima:=P_Ima^.Next;
     end;

     P_Img:=P_Ima^.image;

     for i:=1 to which_frame do
     begin
          if i=which_frame then break;
          if P_Img^.Next=nil then WriteExitMsg('Frame in sprite not found.');
          P_Img:=P_Img^.Next;
     end;

     GetFrame:=@P_Img^.Img;
end;


function  GetMaxFrame(P_Ima: P_Images; which_sprite: word): word;
var  i     : word;
     P_Img : P_Image;
begin

     for i:=1 to which_sprite do
     begin
          if i=which_sprite then break;
          if P_Ima^.Next=nil then WriteExitMsg('Sprite not found.');
          P_Ima:=P_Ima^.Next;
     end;

     P_Img:=P_Ima^.image;

     i:=0;
     repeat
          inc(i);
          if P_Img^.Next=nil then break;
          P_Img:=P_Img^.Next;
     until false;

     GetMaxFrame:=i;
end;



function GetShipPos(Epi: P_Episodes; which_epi,which_lev,which_shi: word): P_ShipsPos;
var  P_Lev : P_Levels;
     P_Shi : P_ShipsPos;
     i     : word;
begin

     for i:=1 to which_epi do
     begin
          if i=which_epi then break;
          Epi:=Epi^.Next;
          if Epi = nil then break;
     end;

     P_Lev:=Epi^.Levels;
     if p_lev=nil then writeexitmsg('Level branche in episode have NULL assignment.');

     for i:=1 to which_lev do
     begin
          if i=which_lev then break;
          P_Lev:=P_Lev^.Next;
          if P_Lev = nil then WriteExitMsg('Wanted level DO NOT exists.');
     end;

     P_Shi:=P_Lev^.ShipsPos;
     if p_shi=nil then writeexitmsg('Ships positions in level have NULL assignment.');

     for i:=1 to which_shi do
     begin
           if i=which_shi then break;
           P_Shi:=P_Shi^.Next;
           if P_Shi = nil then WriteExitMsg('Wanted ship position DO NOT exists.');
     end;

     GetShipPos:=P_Shi;
end;


procedure DisposeShipPos(Epi: P_Episodes; which_epi,which_lev,which_shi: word);
var  P_Lev : P_Levels;
     P_Shi : P_ShipsPos;
     i     : word;
begin

     for i:=1 to which_epi do
     begin
          if i=which_epi then break;
          Epi:=Epi^.Next;
          if Epi = nil then break;
     end;

     P_Lev:=Epi^.Levels;
     if p_lev=nil then writeexitmsg('Level branche in episode have NULL assignment.');

     for i:=1 to which_lev do
     begin
          if i=which_lev then break;
          P_Lev:=P_Lev^.Next;
          if P_Lev = nil then WriteExitMsg('Wanted level DO NOT exists.');
     end;

     P_Shi:=P_Lev^.ShipsPos;
     if p_shi=nil then writeexitmsg('Ships positions in level have NULL assignment.');

     if which_shi=1 then
        begin
             freem(P_Lev^.ShipsPos,sizeof(t_shipspos));
             P_Lev^.ShipsPos:=nil;
        end else
     for i:=1 to which_shi do
     begin
           if i+1=which_shi then
              begin
                   freem(P_Shi^.Next,sizeof(t_shipspos));
                   P_Shi^.Next:=nil;
                   break;
              end;
           p_shi:=p_shi^.next;
           if P_Shi = nil then WriteExitMsg('Wanted ship position DO NOT exists.');
     end;
end;


procedure DisposeIntro(var p_int: p_intro);
var  p: pointer;
begin
     if p_int <> nil then            { Zwolnienie intra }
     begin
           p:=p_int;
           freem(P_Intro(p)^.text,P_Intro(p)^.size);

           p:=p_int^.image;
           if p_int^.image^.img.pal_exist then
           freem(p_image(p)^.img.pal,3*256);

           p:=p_int^.image;
           freem(p_image(p)^.img.data,p_image(p)^.img.size);

           p:=p_int^.image;
           freem(p,sizeof(t_image));

           p:=p_int;
           freem(p,sizeof(T_Intro));
           p_int:=nil;
     end;
end;


procedure DisposeLevel(var P_Lev: P_Levels);
var  p_shi : P_ShipsPos;
     p     : pointer;
begin
     p_shi:=P_Lev^.ShipsPos;
     repeat
           p:=p_shi;
           freem(p,sizeof(T_ShipsPos));
           if p_shi^.next = nil then break;
           p_shi:=p_shi^.next;
     until false;

     DisposeIntro(P_Lev^.Intro);
     freem(p_lev,sizeof(t_levels));
     p_lev:=nil;
end;


function LastShipPos(Epi: P_Episodes; var which_epi,which_lev: word): P_ShipsPos;
var  P_Epi     : P_Episodes;
     P_Epi_tym : P_Episodes;
     P_Lev     : P_Levels;
     P_Lev_tym : P_Levels;
     P_Shi     : P_ShipsPos;
     P_Shi_tym : P_ShipsPos;
     i,tym     : word;
begin

     if epi=nil then WriteExitMsg('Episode link have null assignment.');

if which_epi=1 then P_Epi:=Epi;
if which_epi>1 then
begin
     P_Epi_Tym:=Epi;
     P_Epi:=Epi^.Next;

     For i:=1 to which_epi-1 do
     begin
          if P_Epi=nil then
             begin
                  P_Epi_Tym^.Next:=reserve_mem(sizeof(t_episodes));
                  P_Epi:=P_Epi_Tym^.Next;
                  P_Epi^.Levels:=nil;
                  P_Epi^.Next:=nil;
                  break;
             end;
          if i=which_epi-1 then break;
          P_Epi:=P_Epi^.Next;
          P_Epi_Tym:=P_Epi_Tym^.Next;
     end;
end;

     if P_epi^.Levels=nil then
        begin
             P_epi^.Levels:=reserve_mem(sizeof(t_levels));
             P_Lev:=P_Epi^.Levels;
             P_Lev^.next:=nil;
             P_lev^.shipspos:=nil;
        end;

if which_lev=1 then P_Lev:=P_Epi^.Levels;
if which_lev>1 then
begin
     P_lev_Tym:=p_Epi^.levels;
     P_lev:=P_Epi^.levels^.Next;

     For i:=1 to which_lev-1 do
     begin
          if P_Lev=nil then
             begin
                  P_lev_Tym^.Next:=reserve_mem(sizeof(t_levels));
                  P_lev:=P_lev_Tym^.Next;
                  P_Lev^.next:=nil;
                  P_lev^.shipspos:=nil;
                  break;
             end;
          if i=which_lev-1 then break;
          P_Lev:=P_Lev^.Next;
          P_Lev_Tym:=P_Lev_Tym^.Next;
     end;
end;

     if P_Lev^.Shipspos=nil then
        begin
             P_Lev^.Shipspos:=reserve_mem(sizeof(t_shipspos));
             P_Shi:=P_Lev^.shipspos;
             P_Shi^.next:=nil;
        end else
begin
     P_Shi_Tym:=p_lev^.shipspos;
     P_Shi:=P_lev^.shipspos^.Next;
     repeat
          if P_Shi=nil then
             begin
                  P_Shi_Tym^.Next:=reserve_mem(sizeof(t_shipspos));
                  P_Shi:=P_Shi_Tym^.Next;
                  P_Shi^.next:=nil;
                  break;
             end;
          P_Shi:=P_Shi^.Next;
          P_Shi_Tym:=P_Shi_Tym^.Next;
     until false;
end;

     LastShipPos:=P_Shi;
end;


end.