(*
        SpaceSweeper Main part
        Main game engine.

        Author: Piotr Skowronek, pskowronek@adfinem.net
        Written in: 1997
        Licence: LGPL
 *)

program Gra_w_rozdzielczosci_320x200x256;

{ $DEFINE BETATEST}       { Wuci spacj przed $ aby wyczy BETA-test }

{$IFDEF BETATEST}
{$I-,R+,G+,S+,D+,Q-}
{$ELSE}
{$I-,R-,G+,S-,D-,Q-,V-,B-}
{$ENDIF}
{$M 10000,10000,650000}

uses DOS,SINCOS,MOUSE,READDAT,TYPES,MISC,KEYBOARD;
const
  {$IFDEF BETATEST}
     BETA_test   : Boolean = True;
     sciezka_EXE : string[20] = 'c:\temp\gra\bmp\';
     ResourceName =  'c:\game.dat';
  {$ELSE}
     BETA_test   : Boolean = False;
     sciezka_EXE : string[20] = '';
     ResourceName =  'game.dat';
  {$ENDIF}
     xp           =  84;
     xk           =  320-8;
     yp           =  0;
     yk           =  200;
     Font1_name   =  'FONTS#1.FON';
     Font2_name   =  'FONTS#2.FON';

     ScrnShot_Name  =  'sshot';         { Nazwa pliku do ktrego zrzuca }
     Config_Name =  'game.cfg';
{ Kolory }

     Yes = True;
     No  = False;

     Config_changed : boolean = false;        { Czy zmieniano configuracje ? }
     Configuration  : record
                          ID     : string[11];
                          SFX    : Boolean;
                          MUSIC  : Boolean;
                          JOY    : Boolean;
                          XCEN,YCEN,
                          XMIN,YMIN,
                          XMAX,YMAX : Word;
                      end = (ID:'GAME-CONFIG';SFX:NO;MUSIC:NO;
                             JOY:NO;XCEN:0;YCEN:0;XMIN:0;YMIN:0;XMAX:0;YMAX:0);


(***************** Desktop values ****************)

     Current_Score : Longint = 0;
     Current_Level : word    = 1;
     Game_Status   : (Running,Crash,GameOver)=Running;
{     Game_Status   : (Running,Crash,GameOver,Paused,Nothing) = Running;}

(*************************************************)
     step_X     =  7;
     step_Y     =  7;
     Max_stars  =  50;
     Game_Name  =  'SPACE SWEEPER - The Moon''s orbit';
     Game_Info1 =  'SPACE SWEEPER';
     Game_Info2 =  ' - The Moon''s orbit';
     Game_Info3 =  'v0.9 BETA, 01st Apr 1997';
     Game_Info4 =  '                by Piotrek Skowronek';
     Game_Info5 =  '                   Poland, Cracow';
     Game_Info6 =  '                   E-mail: pskowronek@adfinem.net';

     Wait_MSG   =  'Please wait, while loading...';
     Corner_Status : string = '';   { Do wyw. co si dzieje w rogu jak DOOM }

     x_statku   :  word = xp + (xk-xp) div 2;        { Pozycja statku }
     y_statku   :  word = yk - 50;
     MAX_Flying :  word = 0;
     MAX_Alian_Loaded : word = 0;
     MAX_Explode = 50;

type virtual_bufor = array[0..199+4,0..319] of byte; { Ekran roboczy }
     dword         = longint;

     P_Font     = ^T_Font;
     T_Font     = array [1..10] of
                  record
                        used      : boolean;     { Is used ? }
                        count     : byte;        { Chyba Max ilo liter }
                        xmax,ymax : word;        { Wys. & Szer. liter }
                        size      : word;        { Wielko pamici dla point }
                        point     : pointer;     { pointer to font }
                  end;

     P_Menu = ^T_Menu;
     T_Menu = record
                 title : string[30]; { Nazwa SUBMENU }
                 name  : string[30]; { Nazwa menu, opcji, procedury }
                 xp,yp,              { Wielko SUBMENU }
                 xk,yk : word;
                 ypos  : byte;       { Pozycja kursora w SUBMENU }
                 what  : (submenu,operation,option);  { Co tu si robi }
                 call  : procedure;  { Rozdwojenie do wywoania proc (operation) }
                 where : P_Menu;     { Rozdwojenie do submenu lub opcji }
                 next  : P_Menu;     { Wsk. do nastpnej operacji }
              end;



(*********** Z M I E N N E
 ***********)
     var  virtual_screen  : ^virtual_bufor;      { Ekran roboczy          }
          s_virt,o_virt   : word;                { Na seg i ofs roboczego }
          Explode_Ships   : array [1..100] of    { Rozszczepienie }
                  record
                        used      : boolean;     { Is used ? }
                        xpos,ypos : integer;     { Pocztkowa pozycja wybuchu }
                        add,accel : word;        { Add - przemieszczenie }
                        TheEnd    : byte;        { Ile jeszcze gwiazd w locie }
                        explode   : array[1..max_explode] of
                                         record
                                             kat,odl : word;
                                             max     : byte;  { Max odl }
                                         end;
                  end;

          Fighter_Crash   : record
                                  Xpos,Ypos,Sprite,Frame,Temp,Delay: word;
                            end;
          font            : T_font;              { Czcionki               }
          BMP_tlo         : T_BMP_Sprite;        { Przesuwajce si to   }
          i,j             : word;                { Dla ptli              }
          old_int1c       : pointer;
          oldexitproc     : pointer;
          HEAP_state      : pointer;
          Menu_Tab        : P_Menu;
          frame           : byte;

(****************************************************)

          bomb            : array [1..100] of record x,y : word; fly : boolean; end;
          Which_Kit       : word;   { Ktry zestaw }

          Which_Level     : word;   { Ktry level }
          Which_Episode   : word;   { Ktry expisod }

          which_fighter_sp : word;
          which_fighter_fr : word;

          Max_Marked      : word;   { Max. ilo wyznaczonych }
          Max_Episodes    : word;
          Screen_Pos      : word;   { Pozycja przysuwajcego }
          P_Ship          : P_ShipsPos;
          GameKit         : p_kit;
          Episode         : t_episodes;
          Free_HEAP       : pointer;


(************************ Koniec zmiennych **************************)

Procedure New_Procedure; FORWARD;

procedure initgraph256; assembler;
asm
        mov     ax,0013h
        int     10h
end;

procedure txt_mode; assembler;
asm
        mov     ah,0fh
        int     10h
        cmp     al,03h
        jz      @Juz_w_textowym

        mov     ax,0003h
        int     10h

@Juz_w_textowym:
end;

procedure clrscr(atr: byte); assembler;     { IN:  Atrybut }
asm
        mov     ax,0600h
        mov     bh,atr
        xor     cx,cx
        mov     dx,184fh
        int     10h
end;

procedure putchar(znak,atr: byte; ile: word); assembler;
asm
        mov     ah,0fh
        int     10h                         { Return in BH active page }

        mov     ah,09h
        mov     al,znak
        mov     bl,atr
        mov     cx,ile
        int     10h
end;

procedure GotoXY(x,y: byte); assembler;
asm
        mov     ah,0fh
        int     10h                       { Returns in BH active page }

        mov     ah,02h
        mov     dh,y
        mov     dl,x
        int     10h
end;

procedure putstring(x,y,atr: byte; napis: string);
var s,o: word;
begin
s:=seg(napis);                  { Trzeba tak bo gnj (pascal) co le }
o:=ofs(napis);                  { podkada adres jak si robi w ASM.  }
asm
        mov     ah,0fh
        int     10h                         { Return in BH active page }

        push    es
        push    bp

        mov     dl,x
        mov     dh,y
        mov     bl,atr
        mov     es,s
        mov     bp,o
        xor     ch,ch
        mov     cl,byte ptr es:[bp]
        inc     bp
        mov     ax,1301h
        int     10h

        pop     bp
        pop     es
end;
end;


procedure Save_Configuration;                   { Zapis konfiguracji }
var  f : file;
begin
     IF NOT Config_Changed Then Exit;
     Write('Updating configuration: ');
     FileMode:=1;
     Assign(f,sciezka_EXE+Config_Name);
     SetFAttr(F, Archive);
     ReWrite(f,1);
     IF IOResult<>0 Then begin Writeln('FAILD!'); exit; end;
     BlockWrite(f,Configuration,SizeOF(Configuration));
     Close(f);
     Writeln('DONE.');
end;

procedure Read_Configuration;                   { Odczyt konfiguracji }
var  f  : file;
     ID : string[11];
begin
     FileMode:=0;
     Assign(f,sciezka_EXE+Config_Name);
     Reset(f,1);
     IF IOResult<>0 Then exit;                  { W mem s domylne }
     BlockRead(f,ID,SizeOf(ID));
     IF ID<>'GAME-CONFIG' Then begin close(f); exit; end;
     IF FileSize(f)<>SizeOF(Configuration) then begin close(f); exit; end;
     Seek(f,0);
     BlockRead(f,Configuration,SizeOF(Configuration));
     Close(f);
end;


{$F+}
procedure MyExitProc; far;
begin
SetIntVec($1c,Old_int1c);
Restore_Keyboard;
txt_mode;
if ExitCode<>0 then
   begin
        write('FATAL: Error no: [',ExitCode:3,'] - ');
   end;
case ExitCode of
  0 : ;
  2 : writeln('File not found.');
  3 : writeln('Path not found.');
  4 : writeln('Too many open files.');
  5 : writeln('File access denied.');
100 : writeln('Disk read error.');
101 : writeln('Disk write error.');
106 : writeln('Invalid numeric format.');
150 : writeln('Disk is write protected.');
152 : writeln('Disk not ready.');
162 : writeln('Hardware error.');
200 : writeln('Division by zero.');
201 : writeln('Range check error.');
202 : writeln('Stack overflow error.');
203 : writeln('Heap overflow (not enough memo?).');
204 : writeln('Invalid pointer operation.');
255 : writeln('[!] Ctrl-Break pressed [!] (What for?)');
Else Writeln('Unanticipated error. Report kindly requested.');
end;
if ExitCode<>0 then
   begin
        writeln('PROGRAM HALTED.');
        Writeln('Postmortem dump:');
        Writeln('  Mem available in program : ',MemAvail,'B');
        Writeln('  Max contiguous    -//-   : ',MaxAvail,'B');
        Release(HEAP_state);                       {  Zwolnienie pamici  }
        Writeln('  Mem available actually   : ',MemAvail,'B');
        Writeln('  Max contiguous    -//-   : ',MaxAvail,'B');
        Writeln('  Stack - SS:SP            : ',Byte2Hex(Hi(SSeg)),
                                                Byte2Hex(Lo(SSeg)),':',
                                                Byte2Hex(Hi(SPtr)),
                                                Byte2Hex(Lo(SPtr)));
        Writeln;
   end;
If ExitCode=0 Then Release(HEAP_state);            {  Zwolnienie pamici  }
exitproc:=oldexitproc;
end;
{$F-}


procedure the_end;
begin
Release(HEAP_state);               {  Zwolnienie pamici  }
clear_keyboard;
memW[$0:$417]:=0;                  { Wyzerowanie stanu specjalnych }
Txt_Mode;

ClrScr(15);
GotoXY(0,0);
putchar(32,31,80);
putstring((80 shr 1) - Length(game_name) shr 1,0,31,Game_Name);
GotoXY(0,2);
IF ExitCode=0 Then Writeln('Smooth exit...');
writeln;
Save_Configuration;
writeln;
writeln('Maximum memo available under 640k  :  ',MemAvail:6,'B');
writeln('Largest contiguous block available :  ',MaxAvail:6,'B');
writeln;

writeln(Game_Info1+Game_Info2+', '+Game_Info3);
writeln(Game_Info4);
writeln(Game_Info5);
writeln(Game_Info6);
writeln;
halt;
end;

procedure Check4Error(name: string);
var  Blad : Integer;
begin
     Blad:=IOResult;
     IF Blad=0 Then Exit;
     txt_mode;
     Writeln('FATAL: Was an error [no. ',Blad,'] while reading resource file.');
     Writeln('       Name of file is: <',name,'>,');
     Write  ('       check for his existing.  ');
     Writeln('PROGRAM HALTED');
     Halt;
end;


procedure setrgbpal(s,o:word); assembler;       { Set RGB palete colorow }
asm                                             { Proc zapisu palety RGB  }
        push    ds
        mov     ds,ss:s
        mov     si,ss:o

        mov     cx,256*3
        mov     dx,3c8h
        xor     al,al
        out     dx,al
        inc     dx
        cld
@petel:
        outsb
        loop    @petel
        pop     ds
end;


procedure getrgbpal(s,o:word); assembler;
asm                        { Proc odczyt palety RGB }
{        push    es
        mov     es,ss:s
        mov     di,ss:o
        mov     cx,256*3
        mov     dx,3c8h
        mov     ax,1
        out     dx,ax
        inc     dx
        cld
        rep     insb
        pop     es}
        mov     ax,1017h
        mov     es,s
        mov     dx,o
        xor     bx,bx
        mov     cx,$100
        int     10h
end;

procedure move_data;assembler;
     asm
         cli
         mov    dx,03DAh
@Vert:   in     al,dx               { Czeka na pionowy, 3bit=1 }
         test   al,08h
         je     @Vert

@Wait:   in     al,dx               { Czeka a 0bit=0 (faza ciemna)}
         rcr    al,1
         jc     @Wait

         push   ds
         xor    si,si
         mov    ds,[ds:s_virt]
         xor    di,di
         mov    dx,0a000h
         mov    es,dx
         mov    cx,16000       {  64000 / 4  }
         cld
db $66;  rep    movsw          {  REP  MOVSD  (32bit)  }
         pop    ds
         sti
     end;

procedure line(xp,yp,xk,yk: word; col: byte); assembler;
var wsk1    : word;
    wsk2    : word;
    podpr   : word;
asm
        push    si
        push    di
        mov     es,ds:s_virt
        mov     si,320
        mov     cx,xk
        sub     cx,xp
        jz      @VL
        jns     @pdr1
        neg     cx
        mov     bx,xk
        xchg    bx,xp
        mov     xk,bx
        mov     bx,yk
        xchg    bx,yp
        mov     yk,bx
@pdr1:
        mov     bx,yk
        sub     bx,yp
        jz      @HL
        jns     @pdr3
        neg     bx
        neg     si
@pdr3:
        push    si
        mov     podpr,offset @LL1
        cmp     bx,cx
        jle     @pdr4
        mov     podpr,offset @HL1
        xchg    bx,cx
@pdr4:
        shl     bx,1
        mov     wsk1,bx
        sub     bx,cx
        mov     si,bx
        sub     bx,cx
        mov     wsk2,bx
        push    cx
        mov     ax,yp
        mov     bx,xp
        xchg    ah,al
        add     bx,ax
        shr     ax,2
        add     bx,ax

        mov     di,bx
        pop     cx
        inc     cx
        pop     bx
        jmp     podpr
@VL:
        mov     ax,yp
        mov     bx,yk
        mov     cx,bx
        sub     cx,ax
        jge     @pdr31
        neg     cx
        mov     ax,bx
@pdr31:
        inc     cx
        mov     bx,xp
        push    cx

        xchg    ah,al
        add     bx,ax
        shr     ax,2
        add     bx,ax

        pop     cx
        mov     di,bx
        dec     si
        mov     al,col
@pdr32:
        stosb
        add     di,si
        loop    @pdr32
        jmp     @Exit
@HL:
        push    cx
        mov     ax,yp
        mov     bx,xp
        xchg    ah,al
        add     bx,ax
        shr     ax,2
        add     bx,ax

        mov     di,bx
        pop     cx
        inc     cx
        mov     al,col
        rep     stosb
        jmp     @Exit
@LL1:
        mov     al,col
@pdr11:
        stosb
        or      si,si
        jns     @pdr12
        add     si,wsk1
        loop    @pdr11
        jmp     @Exit
@pdr12:
        add     si,wsk2
        add     di,bx
        loop    @pdr11
        jmp     @Exit
@HL1:
        mov     al,col
@pdr21:
        stosb
        add     di,bx
@pdr22:
        or      si,si
        jns     @pdr23
        add     si,wsk1
        dec     di
        loop    @pdr21
        jmp     @Exit
@pdr23:
        add     si,wsk2
        loop    @pdr21
@Exit:
        pop     di
        pop     si
end;



Function reserve_mem(size: word): pointer;      { Alokacja miejsca w pamici }
var  P: Pointer;
begin
     IF MaxAvail<Size Then
        begin
             txt_mode;
             writeln('FATAL: Not enough memo to continue program.');
             writeln('       Free about over ',Size-MaxAvail,' bytes and try again.');
             writeln('           --- PROGRAM HALTED ---');
             halt;
        end;
     GetMem(P,size);
     Reserve_Mem:=P;
end;


(***************************** Zrzucanie do BMPy ****************************)
function drop_the_screen: boolean;
const  ile_zrzuconych : word = 0;
       BMP_Header     : BMP_File_Hdr_Type =
                      (bfType:256*77+66;
                       bfSize:65078;
                       bfReserve1:0;
                       bfReserve2:0;
                       bfOffBits:1078);
       BMP_Info       : BMP_Info_Hdr_Type =
                      (biSize:40;
                       biWidth:320;
                       biHeight:200;
                       biPlanes:1;
                       biBitCount:8;
                       biCompression:0;
                       biSizeImage:320*200;
                       biXPelsPerMeter:0;
                       biYPelsPerMeter:0;
                       biClrUsed:0;
                       biClrImportant:0);
var   paleta_BMP : array [1..256] of record
                                          r,g,b,nic : byte;
                                     end;
      paleta     : array [1..256] of record
                                          r,g,b : byte;
                                     end;
      i          : word;
      name       : string[15];
      plik       : file;
begin
Drop_The_Screen:=False;
GetRGBPal(Seg(paleta),Ofs(Paleta));
for i:=1 to 256 do
    begin
         paleta_BMP[i].R:=paleta[i].B shl 2;
         paleta_BMP[i].G:=paleta[i].G shl 2;
         paleta_BMP[i].B:=paleta[i].R shl 2;
         paleta_BMP[i].nic:=0;
    end;
str(ile_zrzuconych,name);
inc(ile_zrzuconych);
name:=scrnshot_name+name+'.BMP';
FileMode:=1;
assign(plik,sciezka_EXE+name);
SetFAttr(plik,0);
rewrite(plik,1);                                     IF IOResult<>0 Then exit;
BlockWrite(plik,BMP_header,SizeOf(BMP_header));      IF IOResult<>0 Then exit;
BlockWrite(plik,BMP_Info,SizeOf(BMP_Info));          IF IOResult<>0 Then exit;
BlockWrite(plik,paleta_BMP,SizeOf(paleta_BMP));      IF IOResult<>0 Then exit;
for i:=199 downto 0 do
    BlockWrite(plik,virtual_screen^[i],320);
                                                     IF IOResult<>0 Then exit;
close(plik);
Drop_The_Screen:=True;
end;



(****************************** Odczyt BMP'w *******************************)
procedure Read_Sprite(path: string; var BMP_Sprite: T_BMP_Sprite; ReadPal: Boolean);
Type
    tab = array [1..256] of record
                                  r,g,b,nic : byte;
                            end;
Var i          : word;
    bmp        : file;
    BMPFileHdr : ^BMP_File_Hdr_Type;
    BMPInfoHdr : ^BMP_Info_Hdr_Type;
    Tym        : ^tab;
    Head       : dword;
    Xmax,Ymax  : integer;
    P          : pointer;
begin
FileMode:=0;
assign(bmp,path);
reset(bmp,1);
Check4Error(path);

BMPFileHdr:=Reserve_Mem(SizeOf(BMP_File_Hdr_Type));
BMPInfoHdr:=Reserve_Mem(SizeOf(BMP_Info_Hdr_Type));
BlockRead(bmp,BMPFileHdr^,SizeOf(BMP_File_Hdr_Type));
BlockRead(bmp,BMPInfoHdr^,SizeOf(BMP_Info_Hdr_Type));
IF (BMPFileHdr^.bfType<>256*77+66) or (BMPInfoHdr^.biPlanes<>1) or
   (BMPInfoHdr^.biBitCount<>8) or (BMPInfoHdr^.biCompression<>0) Then
   begin
        txt_mode;
        writeln('FATAL: Unsupported BMP file.');
        writeln('       File name: [',path,'].');
        close(bmp);
        halt;
   end;
Xmax:=BMPinfoHdr^.biWidth;
Ymax:=BMPInfoHdr^.biHeight;
Head:=BMPFileHdr^.bfOffBits;
If xmax mod 4<>0 then xmax:=(trunc(xmax/4))*4+4;
FreeMem(BMPFileHdr,SizeOf(BMP_File_Hdr_Type));
FreeMem(BMPInfoHdr,SizeOf(BMP_Info_Hdr_Type));

IF ReadPal Then
begin
Tym:=Reserve_Mem(SizeOf(tab));
BMP_Sprite.Pal:=Reserve_Mem(SizeOf(paleta));
seek(bmp,$36);
BlockRead(bmp,Tym^,sizeof(Tab));               { Get Palette from BMP }
for i:=1 to 256 do
    begin
         BMP_Sprite.Pal^[i].R:=Tym^[i].B shr 2;
         BMP_Sprite.Pal^[i].G:=Tym^[i].G shr 2;
         BMP_Sprite.Pal^[i].B:=Tym^[i].R shr 2;
    end;
FreeMem(Tym,SizeOf(tab));
BMP_Sprite.Pal_Exist:=True;
end else
BMP_Sprite.Pal_Exist:=False;

BMP_Sprite.Data:=Reserve_Mem(FileSize(BMP)-head);

Seek(BMP,Head);
BlockRead(BMP,BMP_Sprite.Data^,FileSize(BMP)-Head);
BMP_Sprite.Xmax:=Xmax;
BMP_Sprite.Ymax:=Ymax;
BMP_Sprite.Size:=FileSize(BMP)-head;

close(bmp);
end;

procedure delay(op: longint);
var c,d: word;
begin
d:=op and $FFFF;
c:=op shr 16;
asm
        mov     ah,86h
        mov     dx,d
        mov     cx,c
        int     15h
end;
end;


procedure fade_down;
var   pal : array [1..769] of byte;
      i,j : word;
begin
GetRGBpal(seg(pal),ofs(pal));
For j:=1 to 63 do
    begin
         for i:=1 to 769 do
             if pal[i]<>0 then dec(pal[i]);
         Repeat Until port[$3da] and 8=8;      { Vertical return }
         SetRGBpal(seg(pal),ofs(pal));
    end;
end;

procedure fade_up(s,o: word);
var   pal  : array [1..769] of byte;
      i,j  : word;
begin
FillChar(pal,SizeOf(pal),#0);
For j:=1 to 63 do
    begin
         for i:=1 to 769 do
             begin
                  if pal[i]<mem[s:o+i-1] then Inc(pal[i])
                                       Else
                  if pal[i]>mem[s:o+i-1] then Dec(pal[i]);
             end;
         Repeat Until port[$3da] and 8=8;      { Vertical return }
         Repeat Until port[$3da] and 8=8;      { Vertical return }
         SetRGBpal(seg(pal),ofs(pal));
         delay(5000);
    end;
end;


(************************** Nakadanie rysunkw *****************************)
procedure get_background(xp,yp,xk,yk: word; var back: T_BMP_Sprite);
var   tym_ofs   : word;
      xmax,ymax : word;
      s_data,
      o_data    : word;
begin
      xmax:=xk-xp;
      ymax:=yk-yp;
      tym_ofs:=xp+320*(yp+ymax)-320;
      Back.Xmax:=Xmax;
      Back.Ymax:=Ymax;
      Back.Size:=Xmax*Ymax;
      Back.Pal_Exist:=False;
      IF Back.Data=nil Then Back.Data:=Reserve_Mem(Back.Size);
      s_data:=Seg(Back.Data^);
      o_data:=Ofs(Back.Data^);

asm   push  ds
      mov   di,ss:o_data
      mov   si,ss:tym_ofs
      mov   es,ss:s_data
      mov   ds,ds:s_virt
      mov   dx,ss:ymax             { Y-ki maxymalne }
      mov   cx,ss:xmax             { X-y  maxymalne }
      cld
@petla_Y:

      push  cx
      push  si
      rep   movsb                  { Rysowanie lini }
      pop   si
      pop   cx

      sub   si,320                 { Lini do tyu w wirtualnym ekranie }
      dec   dx
jne   @petla_Y
      pop   ds
end;
end;

procedure get_background_2(xp,yp: word; var Input: T_BMP_Sprite; var back: T_BMP_Sprite);
var   tym_ofs   : word;
      xmax,ymax : word;
      s_data,
      o_data    : word;
begin
      s_data:=Seg(Back.Data^);
      o_data:=Ofs(Back.Data^);
      xmax:=input.xmax;
      ymax:=input.ymax;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp+ymax)-320;
      Back.Ymax:=InPut.Ymax;
      Back.Xmax:=InPut.Xmax;
      Back.Size:=InPut.Size;
      Back.Pal_Exist:=False;
asm   push  ds
      mov   di,ss:o_data
      mov   si,ss:tym_ofs
      mov   es,ss:s_data
      mov   ds,ds:s_virt
      mov   dx,ss:ymax             { Y-ki maxymalne }
      mov   cx,ss:xmax             { X-y  maxymalne }
      cld
@petla_Y:

      push  cx
      push  si
      rep   movsb                  { Rysowanie lini }
      pop   si
      pop   cx

      sub   si,320                 { Lini do tyu w wirtualnym ekranie }
      dec   dx
jne   @petla_Y
      pop   ds
end;
end;


procedure Release_Sprite(var InPut: T_BMP_Sprite);
begin
     IF InPut.Data<>nil Then FreeMem(InPut.Data,InPut.Size);
end;




procedure put_image(xp,yp: word; var  InPut: T_BMP_Sprite);
var   tym_ofs   : word;
      s_data,
      o_data    : word;
      xmax,ymax : word;
begin
      xmax:=InPut.Xmax;
      ymax:=InPut.Ymax;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp+ymax)-320;
      s_data:=seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^);

asm   push  ds
      mov   si,[ss:o_data]
      mov   di,[ss:tym_ofs]
      mov   es,[ds:s_virt]
      mov   ds,[ss:s_data]
      mov   dx,[ss:ymax]          { Y-ki }
      mov   cx,[ss:xmax]          { X-y  }
      cld
@petla_Y:

      push  di
      push  cx
      rep   movsb                 { Linia X-w }
      pop   cx
      pop   di

      sub   di,320                { O 1- lini do tyu }
      dec   dx
jne   @petla_Y
      pop   ds
end;
end;


procedure put_image_and_backup(xp,yp: word; var InPut: T_BMP_Sprite; var BackGr: T_BMP_Sprite);
var   tym_ofs   : word;
      Xmax,Ymax : word;
      s_data,
      o_data    : word;
      s_back,
      o_back    : word;
      s_virt_   : word;
begin
      xmax:=InPut.Xmax;
      ymax:=InPut.Ymax;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp+ymax)-320;
      s_data:=Seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^);
      s_back:=Seg(BackGr.Data^);
      o_back:=Ofs(BackGr.Data^);
      s_virt_:=s_virt;
asm   push  ds
      xor   si,si
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   cx,ss:xmax
      cld
@petla_Y:

      push  cx
      mov   ds,ss:s_virt_
      mov   es,ss:s_back
      push  si
      push  di
      xchg  si,di
      add   di,ss:o_back
      rep   movsb
      pop   di
      pop   si
      pop   cx

      push  cx
      mov   es,ss:s_virt_
      mov   ds,ss:s_data
      push  di
      push  si
      add   si,ss:o_data
      rep   movsb
      pop   si
      pop   di
      pop   cx

      add   si,ss:xmax
      sub   di,320
      dec   dx
jne   @petla_Y
      pop   ds
end;
      BackGr.Xmax:=InPut.Xmax;
      BackGr.Ymax:=InPut.Ymax;
      BackGr.Size:=InPut.Size;
end;


procedure put_sprite_and_backup(xp,yp: word; var InPut: T_BMP_Sprite; var BackGr: T_BMP_Sprite);
var   tym_ofs   : word;
      Xmax,Ymax : word;
      s_data,
      o_data    : word;
      s_back,
      o_back    : word;
      s_virt_   : word;
begin
      xmax:=InPut.Xmax;
      ymax:=InPut.Ymax;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp+ymax)-320;
      s_data:=Seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^);
      s_back:=Seg(BackGr.Data^);
      o_back:=Ofs(BackGr.Data^);
      s_virt_:=s_virt;
asm   push  ds
      xor   si,si
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   cx,ss:xmax
      cld
@petla_Y:

      push  cx
      mov   ds,ss:s_virt_
      mov   es,ss:s_back
      push  si
      push  di
      xchg  si,di
      add   di,ss:o_back
      rep   movsb
      pop   di
      pop   si
      pop   cx

      push  cx
      mov   es,ss:s_virt_
      mov   ds,ss:s_data
      push  di
      push  si
      add   si,ss:o_data
  @Petla_X:
      mov   al,ds:[si]
      or    al,al
      jz    @Go
      movsb
  loop      @petla_X
      jmp   @koniec
  @Go:
      inc   si
      inc   di
  loop      @petla_X

@koniec:
      pop   si
      pop   di
      pop   cx

      add   si,ss:xmax
      sub   di,320
      dec   dx
jne   @petla_Y
      pop   ds
end;
      BackGr.Xmax:=InPut.Xmax;
      BackGr.Ymax:=InPut.Ymax;
      BackGr.Size:=InPut.Size;
end;




procedure put_sprite(xp,yp: word; var InPut: T_BMP_Sprite);
var   tym_ofs   : word;
      s_data,
      o_data    : word;
      xmax,ymax : word;
begin
      xmax:=InPut.Xmax;
      ymax:=InPut.Ymax;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp+ymax)-320;
      s_data:=Seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^);
asm   push  ds
      mov   si,ss:o_data
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   es,ds:s_virt
      mov   ds,ss:s_data
      mov   cx,ss:xmax
      cld
@petla_Y:

      push  cx
      push  di


  @petla_X:
      mov   al,ds:[si]
      or    al,al
      jz    @go
      movsb
  loop  @petla_X
      jmp   @koniec
  @go:
      inc   di
      inc   si
  loop  @petla_X

@koniec:
      pop   di
      pop   cx
      sub   di,320
      dec   dx
jne   @petla_Y
      pop   ds
end;
end;


procedure put_sprite_updown(xp,yp: word; var InPut: T_BMP_Sprite);
var   tym_ofs   : word;
      s_data,
      o_data    : word;
      xmax,ymax : word;
      tym       : word;
begin
      xmax:=InPut.Xmax;
      ymax:=InPut.Ymax;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*yp;
      tym:=320-xmax;
      s_data:=Seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^);
asm   push  ds
      mov   si,ss:o_data
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   es,ds:s_virt
      mov   ds,ss:s_data
      mov   cx,ss:xmax
      cld
@petla_Y:

      push  cx


  @petla_X:
      mov   al,ds:[si]
      or    al,al
      jz    @go
      movsb
  loop  @petla_X
      jmp   @koniec
  @go:
      inc   di
      inc   si
  loop  @petla_X

@koniec:
      pop   cx
      add   di,tym
      dec   dx
jne   @petla_Y
      pop   ds
end;
end;



procedure put_sprite_from_to(xp,yp,From_pos,To_pos: word; var InPut: T_BMP_Sprite);
var   tym_ofs   : word;
      s_data,
      o_data    : word;
      xmax,ymax : word;
begin
      xmax:=InPut.Xmax;
      ymax:=InPut.Ymax;
      IF ymax-to_pos<=from_pos Then exit;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp+ymax-from_pos-to_pos)-320;
      s_data:=Seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^)+to_pos*xmax;
      ymax:=ymax-(from_pos+to_pos);
asm   push  ds
      mov   si,ss:o_data
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   es,ds:s_virt
      mov   ds,ss:s_data
      mov   cx,ss:xmax
      cld
@petla_Y:

      push  cx
      push  di


  @petla_X:
      mov   al,ds:[si]
      or    al,al
      jz    @go
      movsb
  loop  @petla_X
      jmp   @koniec
  @go:
      inc   di
      inc   si
  loop  @petla_X

@koniec:
      pop   di
      pop   cx
      sub   di,320
      dec   dx
jne   @petla_Y
      pop   ds
end;
end;




procedure put_image_from_to(xp,yp,From_pos,To_pos: word; var InPut: T_BMP_Sprite);
var   tym_ofs   : word;
      s_data,
      o_data    : word;
      xmax,ymax : word;
begin
      xmax:=InPut.Xmax;
      ymax:=InPut.Ymax;
      IF ymax-to_pos<=from_pos Then exit;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp+ymax-from_pos-to_pos)-320;
      s_data:=Seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^)+to_pos*xmax;
      ymax:=ymax-(from_pos+to_pos);

asm   push  ds
      mov   si,[ss:o_data]
      mov   di,[ss:tym_ofs]
      mov   es,[ds:s_virt]
      mov   ds,[ss:s_data]
      mov   dx,[ss:ymax]          { Y-ki }
      mov   cx,[ss:xmax]          { X-y  }
      cld
@petla_Y:

      push  di
      push  cx
      rep   movsb                 { Linia X-w }
      pop   cx
      pop   di

      sub   di,320                { O 1- lini do tyu }
      dec   dx
jne   @petla_Y
      pop   ds
end;


end;


procedure put_image_from_to_updown(xp,yp,From_pos,To_pos: word; var InPut: T_BMP_Sprite);
var   tym_ofs   : word;
      s_data,
      o_data    : word;
      xmax,ymax : word;
begin
      xmax:=InPut.Xmax;
      ymax:=InPut.Ymax;
      IF ymax-to_pos<=from_pos Then exit;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+320*(yp);
      s_data:=Seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^)+from_pos*xmax;
      ymax:=ymax-(from_pos+to_pos);

asm   push  ds
      mov   si,[ss:o_data]
      mov   di,[ss:tym_ofs]
      mov   es,[ds:s_virt]
      mov   ds,[ss:s_data]
      mov   dx,[ss:ymax]          { Y-ki }
      mov   cx,[ss:xmax]          { X-y  }
      cld
@petla_Y:

      push  cx
      rep   movsb                 { Linia X-w }
      pop   cx

      add   di,320
      sub   di,ss:xmax

      dec   dx
jne   @petla_Y
      pop   ds
end;


end;


procedure put_sprite_sin_horiz(xp,yp,from,accel,how_much: word; var  InPut: T_BMP_Sprite);
var   tym_ofs   : word;
      s_data,
      o_data    : word;
      xmax,ymax : word;
      adding    : integer;
      tym_beg   : word;
      dlugosc,y : word;
      tym_end   : word;
      tym_src   : word;
      correc    : word;

begin
      xmax:=InPut.Xmax;
      ymax:=InPut.Ymax;
      if xmax mod 4 <> 0 then correc:=xmax mod 4
                         else correc:=0;

      s_data:=seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^);

      y:=ymax;
      tym_ofs:=xp+320*(yp+ymax)-320;
      tym_src:=o_data;
repeat
      dec(y);
      inc(from,accel);
      if from>359 then from:=0;
      adding:= abs(  sinus_int(from)* longint(how_much) ) shr 13;


      if (from)<180 then
         begin
              if xp+xmax+how_much>320 then
                 begin
                      dlugosc:=xmax-adding;
                      tym_end:=tym_ofs+adding;
                      tym_beg:=tym_src;
                 end
                    else
                 begin
                      dlugosc:=xmax;
                      tym_end:=tym_ofs-adding;
                      tym_beg:=tym_src;
                 end;
         end
              else
         begin
              if integer(xp-how_much)<0 then
                 begin
                      dlugosc:=xmax-adding;
                      tym_end:=tym_ofs;
                      tym_beg:=tym_src+adding;
                 end
                    else
                 begin
                      dlugosc:=xmax;
                      tym_end:=tym_ofs+adding;
                      tym_beg:=tym_src;
                 end;
         end;


asm   push  ds
      mov   si,[ss:tym_beg]
      mov   di,[ss:tym_end]
      mov   es,[ds:s_virt]
      mov   ds,[ss:s_data]
      mov   cx,[ss:dlugosc]       { X-y  }
@loopy:

      mov   al,[ds:si]
      or    al,al
      jz    @dalej
      mov   [es:di],al
@dalej:
      inc   si
      inc   di
      loop  @loopy

      pop   ds
      mov   ax,[ss:xmax]
      sub   [ss:tym_ofs],320
      add   [ss:tym_src],ax
      mov   ax,[ss:correc]
      add   [ss:tym_src],ax
end;
until y=0;

end;


procedure put_image_vert_sqrt(xp,yp,from,accel,how_much: word; var  InPut: T_BMP_Sprite);
var   tym_ofs   : word;
      s_data,
      o_data    : word;
      xmax,ymax : word;
      adding    : integer;
      tym_beg   : word;
      dlugosc,x : word;
      tym_end   : word;
      tym_src   : word;

begin
      xmax:=InPut.Xmax;
      ymax:=InPut.Ymax;
      s_data:=seg(InPut.Data^);
      o_data:=Ofs(InPut.Data^);

      x:=0;
      tym_ofs:=xp+320*(yp+ymax)-320;
      tym_src:=o_data;
repeat
      inc(x);
      inc(from,accel);
      if from>359 then from:=0;
      adding:= abs(  sinus_int(sqrt_int(from)) * longint(how_much) ) shr 13;


      if from<=180 then
         begin
              if yp+ymax+how_much>200 then
                 begin
                      dlugosc:=ymax-adding;
                      tym_beg:=tym_src;
                      tym_end:=tym_ofs-adding*320;
                 end
                    else
                 begin
                      dlugosc:=ymax;
                      tym_beg:=tym_src;
                      tym_end:=tym_ofs-adding*320;
                 end;
         end
              else
         begin
              if integer(yp-how_much)<0 then
                 begin
                      dlugosc:=ymax-adding;
                      tym_beg:=tym_src+adding*xmax;
                      tym_end:=tym_ofs;
                 end
                    else
                 begin
                      dlugosc:=ymax;
                      tym_beg:=tym_src;
                      tym_end:=tym_ofs+adding*320;
                 end;
         end;

asm   push  ds
      mov   si,[ss:tym_beg]
      mov   di,[ss:tym_end]
      mov   es,[ds:s_virt]
      mov   ds,[ss:s_data]
      mov   cx,[ss:dlugosc]       { Y-y  }

      mov   bx,[ss:xmax]
@loopy:
      mov   al,ds:[si]
      mov   es:[di],al            { Linia X-w }
      add   si,bx
      sub   di,320
      loop  @loopy

      pop   ds
      inc   [ss:tym_ofs]
      inc   [ss:tym_src]
end;
until x=xmax;

end;




procedure put_block(xp,yp,xk,yk: word; col : byte);  { Wypeniony prostokt }
var   tym_ofs   : word;
      xmax,ymax : word;
      tym_sub   : word;
begin
      xmax:=xk-xp;
      ymax:=yk-yp;
      IF xp>320 then xp:=xp - (xp div 320)*320;
      IF yp>200 then yp:=yp - (yp div 200)*200;
      tym_ofs:=xp+yp*320;
      tym_sub:=320-xmax;
asm   push  ds
      mov   al,[ss:col]
      mov   di,[ss:tym_ofs]
      mov   es,[ds:s_virt]
      mov   dx,[ss:ymax]          { Y-ki }
      mov   cx,[ss:xmax]          { X-y  }
      cld
@petla_Y:

      push  cx
      rep   stosb                 { Linia X-w }
      pop   cx

      add   di,ss:tym_sub

      dec   dx
jne   @petla_Y
      pop   ds
end;
end;


procedure Read_on_screen(xp,yp: word; path: string; SwitchPAL,Show_0: boolean);
Type
    tab = array [1..256] of record
                                  r,g,b,nic : byte;
                            end;
Var i          : word;
    bmp        : file;
    BMPFileHdr : ^BMP_File_Hdr_Type;
    BMPInfoHdr : ^BMP_Info_Hdr_Type;
    BMPSprite  : T_BMP_Sprite;
    Tym        : ^tab;
    Head       : dword;
    Xmax,Ymax  : integer;
    P          : pointer;
begin
FileMode:=0;
assign(bmp,path);
reset(bmp,1);
Check4Error(path);


BMPFileHdr:=Reserve_Mem(SizeOf(BMP_File_Hdr_Type));
BMPInfoHdr:=Reserve_Mem(SizeOf(BMP_Info_Hdr_Type));
BlockRead(bmp,BMPFileHdr^,SizeOf(BMP_File_Hdr_Type));
BlockRead(bmp,BMPInfoHdr^,SizeOf(BMP_Info_Hdr_Type));
Xmax:=BMPinfoHdr^.biWidth;
Ymax:=BMPInfoHdr^.biHeight;
Head:=BMPFileHdr^.bfOffBits;
If xmax mod 4<>0 then xmax:=(trunc(xmax/4))*4+4;
FreeMem(BMPFileHdr,SizeOf(BMP_File_Hdr_Type));
FreeMem(BMPInfoHdr,SizeOf(BMP_Info_Hdr_Type));
BMPSprite.Data:=Reserve_Mem(FileSize(BMP)-head);
Seek(BMP,Head);
BlockRead(BMP,BMPSprite.Data^,FileSize(BMP)-Head);
BMPSprite.Xmax:=Xmax;
BMPSprite.Ymax:=Ymax;
BMPSprite.Size:=FileSize(BMP)-head;
IF Show_0 Then Put_Image(xp,yp,BMPSprite)     { Wywietli z zerem }
          Else Put_Sprite(xp,yp,BMPSprite);   { Naoy bez zera   }

FreeMem(BMPSprite.Data,BMPSprite.Size);

IF SwitchPAL Then                              { Czy ustawi palet }
begin
Tym:=Reserve_Mem(SizeOf(tab));
BMPSprite.Pal:=Reserve_Mem(SizeOf(paleta));
seek(bmp,$36);
BlockRead(bmp,Tym^,sizeof(Tab));               { Get Palette from BMP }
for i:=1 to 256 do
    begin
         BMPSprite.Pal^[i].R:=Tym^[i].B shr 2;
         BMPSprite.Pal^[i].G:=Tym^[i].G shr 2;
         BMPSprite.Pal^[i].B:=Tym^[i].R shr 2;
    end;
FreeMem(Tym,SizeOf(tab));
SetRGBPal(Seg(BMPSprite.pal^),Ofs(BMPSprite.pal^)); { Set RGB-Palette }
FreeMem(BMPSprite.Pal,SizeOf(paleta));
end;


close(bmp);
end;



(********************** Nakadanie textu ************************)
procedure put_char_XY(xp,yp: word; No,ch,col: byte; InPut: P_Font);
var   tym_ofs       : word;
      tym_add       : word;
      s_data,o_data : word;
      xmax,ymax     : word;
begin
      xmax:=InPut^[no].Xmax;
      ymax:=InPut^[no].Ymax;
      tym_ofs:=xp+320*yp;
      tym_add:=320-xmax;
      s_data:=Seg(InPut^[no].Point^);
      o_data:=Ofs(InPut^[no].Point^)+ch*Xmax*Ymax;

asm   push  ds
      mov   si,ss:o_data
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   es,ds:s_virt
      mov   ds,ss:s_data
      mov   cx,ss:xmax
      cld
@petla_Y:
      push  cx

  @petla_X:
      lodsb                   { mov   al,ds:[si] & inc si }
      or    al,al
      jz    @go
      mov   al,ss:col
      stosb                   { mov   es:[di],al & inc di }
  loop  @petla_X
      jmp   @koniec
  @go:
      inc   di
  loop  @petla_X

@koniec:
      pop   cx
      add   di,ss:tym_add
      dec   dx
jne   @petla_Y
      pop   ds
end;
end;


procedure put_string_XY(xp,yp: word; No : byte; napis: string; col: byte);
var   tym_ofs       : word;        {  ^ Nr czcionki       Color ^ }
      tym_add       : word;
      s_data,o_data : word;
      xmax,ymax     : word;
      i             : word;
begin
      IF Length(napis)=0 Then exit;
      if No=0 then exit;
      xmax:=Font[no].Xmax;
      ymax:=Font[no].Ymax;
      tym_ofs:=xp+320*yp;
      tym_add:=320-xmax;
      s_data:=Seg(Font[no].Point^);

      i:=0;
      IF Font[No].Size<>0 Then          { Tzn e to nie ROMfont }
Repeat
      inc(i);
      o_data:=Ofs(Font[no].Point^)+mem[Seg(napis):Ofs(napis)+i]*Xmax*Ymax;
asm   push  ds
      mov   si,ss:o_data
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   es,ds:s_virt
      mov   ds,ss:s_data
      mov   cx,ss:xmax
      cld
@petla_Y:
      push  cx

  @petla_X:
      lodsb
      or    al,al
      jz    @go
      mov   al,ss:col
      stosb

  loop  @petla_X
      jmp   @koniec
  @go:
      inc   di
  loop  @petla_X

@koniec:
      pop   cx
      add   di,ss:tym_add
      dec   dx
jne   @petla_Y
      pop   ds
end;
      tym_ofs:=tym_ofs+xmax;
until i=Length(napis)
      Else
Repeat
      inc(i);
      o_data:=Ofs(Font[no].Point^)+mem[Seg(napis):Ofs(napis)+i]*Ymax;
asm   push  ds
      mov   si,ss:o_data
      mov   di,ss:tym_ofs
      mov   dx,ss:ymax
      mov   es,ds:s_virt
      mov   ds,ss:s_data
      mov   cx,ss:xmax
      cld
@petla_Y:

      lodsb
      mov   ah,al
      push  cx
      mov   bx,1
      shl   bx,cl
      shl   bx,1
      mov   al,ss:col
  @petla_X:
      shr   bx,1
      test  ah,bl
      jz    @go
      stosb
  loop  @petla_X
      jmp   @koniec
  @go:
      inc   di
  loop  @petla_X

@koniec:

      pop   cx
      add   di,ss:tym_add
      dec   dx
jne   @petla_Y
      pop   ds
end;
      tym_ofs:=tym_ofs+xmax;
until i=Length(napis)
end;


procedure put_string_shadow(xp,yp: word; No : byte; napis: string; col1,col2: byte);
begin
Put_String_XY(xp-1,yp-1,No,napis,col2);
Put_String_XY(xp-1,yp+1,No,napis,col2);
Put_String_XY(xp+1,yp-1,No,napis,col2);
Put_String_XY(xp+1,yp+1,No,napis,col2);
Put_String_XY(xp-1,yp,No,napis,col2);
Put_String_XY(xp+1,yp,No,napis,col2);
Put_String_XY(xp,yp-1,No,napis,col2);
Put_String_XY(xp,yp+1,No,napis,col2);
Put_String_XY(xp,yp,No,napis,col1);
end;


procedure Load_Font(font_name: string);
Type      T_font    = record
                       ID    :  String[10];
                       info  :  String[20];
                       count :  byte;
                       xmax,
                       ymax  :  word;
                      end;
Var       f     : file;
          tym   : T_Font;
          count : word;
          no    : byte;
begin
     for no:=1 to 100 do IF Font[no].Used=False Then begin count:=no; break end;
     FileMode:=0;                      { Read-Only }
     Assign(f,font_name);
     Reset(f,1);
     Check4Error(font_name);
     BlockRead(f,tym,SizeOF(T_Font));
     IF Tym.ID <> 'PS-font   ' Then
        begin
             Txt_Mode;
             Writeln('FATAL: File <',font_name,'> is not correct.');
             Halt;
        end;
     Check4Error(font_name);
     Font[no].Count:=Tym.Count;
     count:=Tym.Count;                    { Bo liczone od Zera }
     Font[no].Xmax:=Tym.Xmax;
     Font[no].Ymax:=Tym.Ymax;
     Font[no].Size:=Count*Tym.Xmax*Tym.Ymax;
     Font[no].Used:=True;
     Font[no].Point:=Reserve_Mem(Count*Tym.Xmax*Tym.Ymax);
     BlockRead(f,Font[no].Point^,Count*Tym.Xmax*Tym.Ymax);
     Check4Error(font_name);
     Close(F);
end;


procedure load_ROM_fonts;
Var       count : word;
          no    : byte;

Function GetROMFontPointer(no: byte): Pointer;    { No - Numer czcionki }
var      s,o : word;
begin
     asm
        push    bp
        push    es

        mov     ax,1130h
        mov     bh,no
        int     10h
        mov     ax,es
        mov     bx,bp

        pop     es
        pop     bp

        mov     s,ax                  { Adres gdzie skadowane s czcionki }
        mov     o,bx
     end;
     GetROMFontPointer:=Ptr(s,o);
end;

begin
     for no:=1 to 100 do IF NOT Font[no].Used Then begin count:=no; break end;
     no:=count;                     { Znalezienie pierwszego wolnego }
     Font[no].Count:=128;
     Font[no].Xmax:=8;
     Font[no].Ymax:=8;
     Font[no].Size:=0;              { Take oznaczenie e to ROM-font }
     Font[no].Used:=True;
     Font[no].Point:=GetROMfontPointer(3); { Czcionka 8x8 0-128 }

     for no:=1 to 100 do IF NOT Font[no].Used Then begin count:=no; break end;
     no:=count;                     { Znalezienie pierwszego wolnego }
     Font[no].Count:=255;
     Font[no].Xmax:=8;
     Font[no].Ymax:=16;
     Font[no].Size:=0;              { Take oznaczenie e to ROM-font }
     Font[no].Used:=True;
     Font[no].Point:=GetROMfontPointer(6); { Czcionka 8x16 0-255 }
end;

procedure Write_Corner_Status(var Corner_Status: string);
const x_st : word = 0;
      y_st : word = 0;
begin
     IF (x_st=x_statku) and (y_st=y_statku) and (Length(Corner_Status)<>0) Then
        put_string_shadow(xp+1,yp+2,4,'MSG: '+Corner_Status,TxtCol_1st,TxtCol_2nd) { Status }
        Else begin
                  Corner_Status:='';                 { Aby status znika }
                  x_st:=x_statku;                    { gdy si poruszy   }
                  y_st:=y_statku;
             end;
end;




(******* Procedury do obsugi Joystick'a ********)
procedure Get_Joy_XY_Direct(var x,y: word);

function Get_value(bit: byte): word;    assembler;
asm
        mov     bl,bit
        mov     dx,0201h
        xor     cx,cx
        cli
(*     @j01:                             { Wyczekanie na ust. rezyst. (bit=0) }
        in      al,dx
        test    bl,al
        je      @j02  loop       @j01
        mov     cx,-1                  { Bd !!! - Time Out, nie ma Joy'a }
        jmp     @wyjscie               { Na I/O nie ustalono rezystancji }*)
     @j02:
        out     dx,al
        in      al,dx
        test    bl,al
        je      @j02
        xor     cx,cx
     @j03:
        in      al,dx
        test    bl,al
        je      @j04
     loop       @j03
        jmp     @wyjscie
     @j04:
        neg     cx
     @wyjscie:
        sti
        mov     ax,cx
end;

begin
     For i:=1 to $FFFF do
         IF port[$201] and 1=0 then     { Wyczekanie na ust. rezyst. (bit=0) }
            begin
                 x:=Get_Value(01);
                 break;
            end else x:=word(-1);       { Bd !!! - Time Out, nie ma Joy'a }
     For i:=1 to $FFFF do
         IF port[$201] and 2=0 then
            begin
                 y:=Get_Value(02);
                 break;
            end else y:=word(-1);


     IF ((x=word(-1)) and (y=word(-1))) or ((x=word(-1)) or (y=word(-1))) then
        begin s_virt:=SegA000;
              Corner_Status:='Joystick not connected.';
              s_virt:=seg(virtual_screen^);
              Configuration.JOY:=NOT Configuration.JOY;
              Config_changed:=True;
              x:=Configuration.Xcen;
              y:=Configuration.Ycen;
        end;
end;

procedure Get_Joy_Status_Direct(var status: byte); assembler;
     asm
        mov     dx,0201h
        in      al,dx
        les     di,ss:[status]
        mov     es:[di],al          { Warto do "status" }
     end;

procedure Center_JOY(var joy_cen_x,joy_cen_y: word);  { Get wyrodkowanie }
var  x,y : word;
begin
     IF NOT Configuration.JOY Then Exit;
     Get_Joy_XY_Direct(x,y);
     joy_cen_x:=x;
     joy_cen_y:=y;
end;

procedure Joy_Calibration(var xcen,ycen,xmin,ymin,xmax,ymax: word);
var  st: byte;
begin
     s_virt:=SEGa000;
     put_string_shadow(125,40,3,'CALIBRATION',TxtCol_1st,TxtCol_2nd);
     put_string_shadow(110,60,4,'Center joystick and press button...',TxtCol_1st,TxtCol_2nd);
     repeat Get_Joy_Status_Direct(st); until (st and 16<>16) or (menu);
     IF MENU Then begin MENU:=False; s_virt:=seg(virtual_screen^); Exit end;
     Center_JOY(xcen,ycen);
     repeat Get_Joy_Status_Direct(st); until (st and 16=16) or (menu);

     put_string_shadow(110,70,4,'Move to top-left and press button...',TxtCol_1st,TxtCol_2nd);
     repeat Get_Joy_Status_Direct(st); until (st and 16<>16) or (menu);
     IF MENU Then begin MENU:=False; s_virt:=seg(virtual_screen^); Exit end;
     Get_Joy_XY_Direct(Xmin,Ymin);
     repeat Get_Joy_Status_Direct(st); until (st and 16=16) or (menu);

     put_string_shadow(110,80,4,'Move to bottom-right and press button...',TxtCol_1st,TxtCol_2nd);
     repeat Get_Joy_Status_Direct(st); until (st and 16<>16) or (menu);
     IF MENU Then begin MENU:=False; s_virt:=seg(virtual_screen^); Exit end;
     Get_Joy_XY_Direct(Xmax,Ymax);
     repeat Get_Joy_Status_Direct(st); until (st and 16=16) or (menu);

     s_virt:=seg(virtual_screen^);
end;




{$F+}
procedure clock_handler; interrupt;
const count : byte = 0;
var   stng: string[10];
begin
     IF NOT BETA_test then exit;          { Tylko do testowania }
     Inc(count);
     IF count<18 then exit;
     Str(MemAvail,Stng);
     put_string_xy(55-length('888888')*9,1,3,'888888',black);
     put_string_xy(55-length(Stng)*9,1,3,stng,white);
     put_string_shadow(58,3,4,'free',white,0);
     Str(frame,Stng);
     put_string_xy(28-length('888')*9,10,3,'888',black);
     put_string_xy(28-length(Stng)*9,10,3,stng,white);
     put_string_shadow(42,12,4,'frms/sec',white,0);
     frame:=0;
     count:=0;
end;
{$F-}


procedure Check_processor;
function i86check: boolean; assembler;     { Spr. czy to 80x86 }
asm
        pushf
        xor     dx,dx
        push    dx
        popf
        pushf
        pop     ax
        cmp     ax,0f000h
        jz      @ThisIs86
        xor     ax,ax
        jmp     @kon

@ThisIs86:
        mov     ax,1
@kon:
        popf
end;
function i286check: boolean; assembler;
asm
        pushf
        mov     ax,0f000h
        push    ax
        popf
        pushf
        pop     ax
        and     ax,0f000h
        jz      @ThisIs286
        xor     ax,ax
        jmp     @kon2

@ThisIs286:
        mov     ax,1
@kon2:
        popf
end;


begin
write('CPU detected: ');
if i86check then
   begin
        writeln('80086 or 80088 (XT).');
        writeln('FATAL: Processor is rather old.');
        writeln('       PROGRAM HALTED.');
        writeln('[!] Change processor to 80386+ and try again :)');
        Halt(1)
   end;

if i286check then
   begin
        writeln('80286 (AT).');
        writeln('FATAL: Processor is rather old.');
        writeln('       PROGRAM HALTED.');
        writeln('[!] Change processor to 80386+ and try again :)');
        Halt(1);
   end;

writeln('80386 or higher.');
end;



procedure init_procedures;
begin
clrscr(15);
GotoXY(0,0);
putchar(32,31,80);
putstring((80 shr 1) - Length(game_name) shr 1,0,31,Game_Name);
GotoXY(0,2);
putchar(Ord(''),11,80);
GotoXY(22,4);
writeln('Please send stinger rocket to the SPA.');
GotoXY(0,6);
putchar(Ord(''),11,80);
GotoXY(0,10);
Check_processor;
Writeln('Initial process...');
writeln;

writeln('Maximum memo available under 640k  :  ',MemAvail:6,'B');
writeln('Largest contiguous block available :  ',MaxAvail:6,'B');
writeln;
randomize;

if NOT BETA_test then
   begin
        sciezka_EXE:=paramstr(0);          { Wydubanie scieki uruchomienia }
        for i:=length(sciezka_EXE) downto 1 do
            if copy(sciezka_EXE,i,1)='\' then break
                                         else delete(sciezka_EXE,i,1);
   end;             { ELSE w "sciezka_EXE" jest beta-scieka }


write('Init virtual screen... ');
virtual_screen:=Reserve_Mem($FFFF);
s_virt:=Seg(virtual_screen^);       { Seg & Ofs ekranu wirtualnego do zmiennych }
o_virt:=Ofs(virtual_screen^);       { Nie uywane bo si mieci w caym seg     }
FillChar(virtual_screen^,$FFFF,0);  { Clean-Up }
writeln('ok.');

write('Loading fonts... ');
load_ROM_Fonts;
load_font(sciezka_EXE+font1_name);
load_font(sciezka_EXE+font2_name);
writeln(' ok.');

Clear_Keyboard;
Set_MAX_speed;                      { ...of keyboard rate }
Read_Configuration;                 { Odczyt konfiguracji }

GetIntVec($1c,Old_int1c);
OldExitProc:=ExitProc;              { Podczepienie mojego epilogu pod RunTime }
ExitProc:=@MyExitProc;
Set_Keyboard;                       { Podczepienie mojej obsugi klawiatury }
SetIntVec($1c,@clock_handler);      { Podczepienie mojej obsugi zegarowego }
end;



procedure Intro;               { <<- Pocztkowe intro }
begin
end;


procedure Put_Bomb(x,y: word);
begin
     Line(x-1,y+1,x-1,y+5,Red);
     Line(x,y+1,x,y+4,LightRed);
     Line(x+1,y+1,x+1,y+5,Red);
     virtual_screen^[y,x]:=yellow;
end;

procedure rectangle(xp,yp,xk,yk: word; col: byte);
begin
     Line(xp,yp,xk,yp,col);
     Line(xp,yp,xp,yk,col);
     Line(xk,yp,xk,yk,col);
     Line(xp,yk,xk,yk,col);
end;


procedure Move_BackGround(bmp_tlo: P_BMP_Sprite);
const kier : boolean = true;
      i    : word    = 1;
begin
     dec(i);
IF (i+200>bmp_tlo^.ymax) and (i<bmp_tlo^.ymax) Then
   begin
        IF kier Then
           begin
             put_image_from_to(xp,yp,i,0,bmp_tlo^);
             put_image_from_to_updown(xp,yp+bmp_tlo^.ymax-i,0,bmp_tlo^.ymax-(200-(yp+bmp_tlo^.ymax-i)),bmp_tlo^)
           end
                Else
           begin
             put_image_from_to_updown(xp,yp,i,0,bmp_tlo^);
             put_image_from_to(xp,yp+bmp_tlo^.ymax-i,0,bmp_tlo^.ymax-(200-(yp+bmp_tlo^.ymax-i)),bmp_tlo^)
           end;
   end
        else
   begin
        IF kier Then
           put_image_from_to(xp,yp,i,bmp_tlo^.ymax-(i+200),bmp_tlo^)
                Else
           put_image_from_to_updown(xp,yp,i,bmp_tlo^.ymax-(i+200),bmp_tlo^);
        If i=0 then begin kier:=not kier; i:=bmp_tlo^.ymax; end;
   end;
end;



Function Is_in_rectangle(xq,yq,xp,yp,xk,yk: integer): boolean;
begin
     IF (xq>xp) and (xq<xk) and (yq>yp) and (yq<yk) Then Is_in_rectangle:=True
                                                    Else Is_in_rectangle:=false;
end;

procedure Load_Levels;
var i, levi, epi : word;
    p_epi        : p_episodes;
    p_lev        : p_levels;
begin
    Release(Free_HEAP);
    if Max_Episodes=0 then Max_Episodes:=GetMaxEpisodes(ResourceName);

{    if Episode.levels<>nil then
    for i:=1 to Max_Episodes do
    begin
         for levi:=1 to 100 do
         begin
         p_lev:=GetLevelPoint(@Episode, i, levi);
         if p_lev=nil then break;
         DisposeLevel(p_lev);
         end;
    end;}
{    if @episode.levels^<>nil then DisposeLevel(Episode.Levels);}

    Episode:=T_Episodes(ReadEpisode(ResourceName,1)^);
    Episode.Levels:=ReadLevel(ResourceName, 1, 1);

    p_epi:=@Episode;
    p_lev:=Episode.Levels;
    epi:=1;
    repeat
    levi:=1;
    while p_lev^.next <> nil do
    begin
         inc(levi);
         p_lev^.next:=P_Levels(ReadLevel(ResourceName, epi, levi));
         p_lev:=p_lev^.next;
         if i=GetMaxLevels(Resourcename,epi) then break;
    end;
    inc(epi);
    if epi=max_episodes+1 then break;

    p_epi^.next:=P_Episodes(ReadEpisode(ResourceName,epi));
    p_epi:=p_epi^.next;
    p_epi^.levels:=P_Levels(ReadLevel(ResourceName, epi, 1));
    p_lev:=p_epi^.levels;
    until false;

end;


procedure Load_Images(_Epi, _Lev: word);
begin
{    if gamekit<>nil then DisposeKit(gamekit);}

    which_kit:=Episode.Levels^.whichkit;
    {if gamekit=nil then} new(gamekit);
    ReadKit(ResourceName,Which_Kit,GameKit);

    which_kit:=GetLevelPoint(@Episode, _epi, _lev)^.whichkit;
    max_marked:=GetLevelPoint(@Episode, _epi, _lev)^.MaxShips;
    screen_pos:=0;

    which_episode:=_epi;
    which_level:=_lev;

    SetColors(GameKit);
    Put_Image(0,0,GameKit^.Cockpit^.Image^.Img);
    DelBranche(GameKit^.Cockpit);
    DelBranche(GameKit^.Colors);
end;



(****************************************************************************)
(****************************************************************************)
procedure UpDate_Bombs;
var  i : word;
begin
     For i:=1 to 100 do
         IF bomb[i].fly Then
            begin
                 Put_Bomb(Bomb[i].x,Bomb[i].y);
                 IF integer(Bomb[i].y-12)<=yp then Bomb[i].Fly:=False;
                 Dec(Bomb[i].y,12);
            end;
end;


procedure Explode;
var   i           : word;
      xtym,ytym   : integer;
      s_tym,c_tym : longint;      { Dla wymnoenia cosinusw i sinusw }
begin
For i:=1 to 30 do               { Animacja rosprysku na kawaki }
    IF Explode_Ships[i].Used Then
       begin
         For j:=1 to MAX_Explode do
          begin
            inc(Explode_Ships[i].explode[j].Odl,2);
            s_tym:=Explode_Ships[i].explode[j].Odl*sinus_int(Explode_Ships[i].explode[j].Kat);
            c_tym:=Explode_Ships[i].explode[j].Odl*cosinus_int(Explode_Ships[i].explode[j].Kat);
            IF s_tym<0 Then xtym:=Explode_Ships[i].Xpos-Abs(s_tym) shr 13
                       Else xtym:=Explode_Ships[i].Xpos+Abs(s_tym) shr 13;
            IF c_tym<0 Then ytym:=Explode_Ships[i].add+Explode_Ships[i].Ypos-Abs(c_tym) shr 13
                       Else ytym:=Explode_Ships[i].add+Explode_Ships[i].Ypos+Abs(c_tym) shr 13;

            IF ((xtym>xp) and (xtym<xk) and (ytym>yp) and (ytym<yk)) and
                (Explode_Ships[i].explode[j].Odl<Explode_Ships[i].explode[j].max) Then
               virtual_screen^[ytym,xtym]:=Yellow
                                              Else
               Dec(Explode_Ships[i].TheEnd);
            IF Explode_Ships[i].TheEnd=0 Then Explode_Ships[i].Used:=False;
          end;
            inc(Explode_Ships[i].add,Explode_Ships[i].accel);
       end;
end;



Procedure Rysuj_Statek(i: word);      { i - ktry statek }
var  xt,yt,wys : integer;
     P_Shi     : P_ShipsPos;
     bmp_point : P_BMP_Sprite;
     which_fr  : word;
     which_sp  : word;
     HeIsDEAD  : boolean;
     stng      : string[7];
begin
     P_Shi:=GetShipPos(@Episode,which_episode,which_level,i);
     if P_Shi^.What=DEAD then Exit;
     if P_Shi^.What=Flying then
     begin
          inc(P_Shi^.Delay);
          which_sp:=P_Shi^.Fly_Case.which;
          if P_Shi^.Delay>3 then
          begin
               P_Shi^.Delay:=0;
               inc(P_Shi^.frame);
               if P_Shi^.frame>GetMaxFrame(GameKit^.Alians, which_sp) then
                  begin P_Shi^.frame:=1;
                  end;
          end;
          which_fr:=P_Shi^.frame;
          bmp_point:=GetFrame(GameKit^.Alians,which_sp,which_fr);

          wys:=bmp_point^.ymax;
          xt:=abs(xp+P_Shi^.x);
          yt:=integer(Screen_Pos+yk-P_Shi^.y);

          IF (yt<yk-yp) and (integer(yt)+wys>yp) Then
          begin
               If (integer(yt+wys)<yk-yp) and (integer(yt)>0) then
                  put_sprite(xt,yt,bmp_point^) else
               If (integer(yt+wys)>=yk-yp) then
                  put_sprite_from_to(xt,yt,0,yt+wys-(yk-yp),bmp_point^) else
               If (yt+wys>yp) then
                  put_sprite_from_to(xt,0,Abs(yt),0,bmp_point^);
          end;
          EXIT;      (**** E X I T I N G ****)
     end;

(**** DIEING ****)
          inc(P_Shi^.Delay);
          which_sp:=P_Shi^.Crash_Case.which;
          if P_Shi^.Delay>3 then
          begin
               P_Shi^.Delay:=0;
               inc(P_Shi^.frame);
               if P_Shi^.frame>GetMaxFrame(GameKit^.Explodes, which_sp) then
                  begin dec(P_Shi^.frame);
                        P_Shi^.What:=DEAD;
                  end;
          end;
          which_fr:=P_Shi^.frame;
          bmp_point:=GetFrame(GameKit^.Explodes,which_sp,which_fr);

          wys:=bmp_point^.ymax;
          xt:=abs(xp+P_Shi^.x);
          yt:=integer(Screen_Pos+yk-P_Shi^.y);

          IF (yt<yk-yp) and (integer(yt)+wys>yp) Then
          begin
               If (integer(yt+wys)<yk-yp) and (integer(yt)>0) then
                  put_sprite(xt,yt,bmp_point^) else
               If (integer(yt+wys)>=yk-yp) then
                  put_sprite_from_to(xt,yt,0,yt+wys-(yk-yp),bmp_point^) else
               If (yt+wys>yp) then
                  put_sprite_from_to(xt,0,Abs(yt),0,bmp_point^);

               IF (yt+10<yk) and (yt>yp) Then
               begin
                    str(GetImgInfo(GameKit^.Alians,P_Shi^.Fly_Case.which)^.Score,stng);
                    put_string_xy(word(xt+11),word(yt+1),4,stng,black);
                    put_string_xy(word(xt+10),word(yt),4,stng,white);
               end;
          end;
end;

procedure Set_Explode_Params(x,y: word); { Ust. rozwalenie 1st wolnego }
var  k,l : word;
begin
           For l:=1 to 30 do               { Animacja rosprysku na kawaki }
               IF NOT Explode_Ships[l].Used Then
               begin
                    Explode_Ships[l].used:=True;
                    Explode_Ships[l].Xpos:=x;
                    Explode_Ships[l].Ypos:=y;
                    Explode_Ships[l].Accel:=1; {In_Fly_Ships[i].accel;}
                    Explode_Ships[l].Add:=0;
                    Explode_Ships[l].TheEnd:=MAX_Explode;
                    For k:=1 to MAX_Explode do
                    begin
                         Explode_Ships[l].explode[k].Kat:=Random(360);
                         Explode_Ships[l].explode[k].Odl:=random(20);
                         Explode_Ships[l].explode[k].max:=random(200);
                    end;
                    break;
               end;  { IF NOT Explode_Ships[l].Used Then }
end;


procedure check4crash(which: word);
var i         : word;
    x,y,xm,ym : integer;
    st_xmax   : word;
    st_ymax   : word;
    P_Shi     : P_ShipsPos;
    bmp_point : P_BMP_Sprite;

begin
    P_Shi:=GetShipPos(@Episode,which_episode,which_level,which);
    bmp_point:=GetFrame(GameKit^.Alians,P_Shi^.Fly_Case.which,1);
    x:=P_Shi^.x+xp;
    y:=integer(Screen_Pos+yk-P_Shi^.y);
    xm:=bmp_point^.xmax;
    ym:=bmp_point^.ymax;
    st_xmax:=GetFrame(GameKit^.Fighters,which_fighter_sp, which_fighter_fr)^.xmax;
    st_ymax:=GetFrame(GameKit^.Fighters,which_fighter_sp, which_fighter_fr)^.ymax;

    For i:=1 to 100 do
      IF (Bomb[i].fly) and (Bomb[i].y>y) and (P_Shi^.What=flying) and
         (Bomb[i].y<y+ym) and (Bomb[i].x>x) and (Bomb[i].x<x+xm) Then
      begin
           if P_Shi^.Crash_Case.How in [stars_image,image] then
              P_Shi^.What:=dieing
           else
              P_Shi^.What:=DEAD;
           Bomb[i].Fly:=False;
           Inc(Current_Score,GetImgInfo(GameKit^.Alians,P_Shi^.Fly_Case.which)^.Score);
           P_Shi^.delay:=0;
           P_Shi^.frame:=0;
           if P_Shi^.Crash_Case.How in [stars,stars_image] then
              Set_Explode_Params(x+xm shr 1,y+ym shr 1);
      end;   { Zderzenia z bomb }

   if Game_Status=Running then
   if (Is_in_rectangle(x,y,x_statku,y_statku,x_statku+st_xmax,y_statku+st_ymax))
      or
      (Is_in_rectangle(x+xm,y+ym,x_statku,y_statku,x_statku+st_xmax,y_statku+st_ymax))
      or
      (Is_in_rectangle(x+xm,y,x_statku,y_statku,x_statku+st_xmax,y_statku+st_ymax))
      or
      (Is_in_rectangle(x,y+ym,x_statku,y_statku,x_statku+st_xmax,y_statku+st_ymax))
         then
      begin
           if P_Shi^.Crash_Case.How in [stars_image,image] then
              P_Shi^.What:=dieing
           else
              P_Shi^.What:=DEAD;
           if P_Shi^.Crash_Case.How in [stars,stars_image] then
              Set_Explode_Params(x+xm shr 1,y+ym shr 1);
           Game_Status:=Crash;
           Fighter_Crash.xpos:=x_statku;
           Fighter_Crash.ypos:=y_statku;
           Fighter_Crash.Sprite:=1;
           Fighter_Crash.Frame:=0;
           Fighter_Crash.Temp:=0;
           Fighter_Crash.Delay:=0;
           Set_Explode_Params(x_statku+xm shr 1,y_statku+ym shr 1);
           Set_Explode_Params(x_statku+xm shr 1,y_statku+ym shr 1);
           Inc(Current_Score,GetImgInfo(GameKit^.Alians,P_Shi^.Fly_Case.which)^.Score);
      end;   { Zderzenia ze statkiem }
end;


procedure UpDate_Alians;               { Poruszanie obcych i check for crash }
var   i,j       : word;

begin
if max_marked=0 then exit;

for i:=1 to max_marked do
begin
     Rysuj_Statek(i);
     if GetShipPos(@Episode,which_episode,which_level,i)^.what=flying then
        check4crash(i);
end;
Explode;                          { Rozwalanie na kawaki }
end;         { Update_Alians }



procedure UpDate_Values;                 { Uaktualnienie wartoci na ekranie }
var  stng: string[20];
begin
     Str(Current_Score,Stng);
     put_string_xy(71-length('8888888')*9,69,3,'8888888',Green);
     put_string_xy(71-length(Stng)*9,69,3,stng,LightGreen);   { Scores }

     line(xp+35,yp+30,xp+45,yp+30,black);    { Krzyyki jak z satelity }
     line(xp+40,yp+25,xp+40,yp+35,black);
     line(xp+35,yk-30,xp+45,yk-30,black);
     line(xp+40,yk-25,xp+40,yk-35,black);
     line(xk-35,yp+30,xk-30-15,yp+30,black);
     line(xk-40,yp+25,xk-40,yp+35,black);
     line(xk-35,yk-30,xk-30-15,yk-30,black);
     line(xk-40,yk-25,xk-40,yk-30-5,black);
     line(xp+(xk-xp) shr 1-2,yp+(yk-yp) shr 1,xp+(xk-xp) shr 1+2,yp+(yk-yp) shr 1,black);
     line(xp+(xk-xp) shr 1,yp+(yk-yp) shr 1-2,xp+(xk-xp) shr 1,yp+(yk-yp) shr 1+2,black);
end;


procedure UpDate_Fighter;                    { Wyrysowanie statku ziemskiego }
const tym   : byte = 0;
begin
     if Game_Status=Running then
     begin
          IF Tym < 1 Then Inc(Tym)   { Opnienie dla klatek }
             Else
          begin
               Tym:=0;
               Inc(which_fighter_fr);       { Nastpna klatka }
               if which_fighter_fr>GetMaxFrame(GameKit^.Fighters,which_fighter_sp) then which_fighter_fr:=1;
          end;


          put_sprite(x_statku,y_statku,GetFrame(GameKit^.Fighters,which_fighter_sp,which_fighter_fr)^);
          EXIT;
     end;
     if Game_Status=Crash then
     begin
          IF Fighter_Crash.temp < 2 Then Inc(Fighter_Crash.temp)  { Opnienie dla klatek }
             Else
          begin
               Fighter_Crash.temp:=0;
               Inc(Fighter_Crash.frame);       { Nastpna klatka }
               if Fighter_Crash.frame>GetMaxFrame(GameKit^.Explodes,Fighter_Crash.Sprite) then
                  begin
                       Fighter_Crash.Frame:=1;
                       Game_Status:=GameOver
                  end;
          end;

{          put_image_vert_sqrt(x_statku,y_statku,tym,5,18,GetFrame(GameKit^.Fighters,which_fighter_sp,which_fighter_fr)^);}
{          put_sprite_sin_horiz(x_statku,y_statku,1,1,50,GetFrame(GameKit^.Fighters,which_fighter_sp,which_fighter_fr)^);}

          put_sprite(Fighter_Crash.xpos,Fighter_Crash.ypos,GetFrame(GameKit^.Fighters,which_fighter_sp,which_fighter_fr)^);
          put_sprite(Fighter_Crash.xpos,Fighter_Crash.ypos,
                     GetFrame(GameKit^.Explodes,Fighter_Crash.sprite,Fighter_Crash.frame)^);
          EXIT;
     end;
     if Game_Status=GameOver then
     begin
          inc(Fighter_Crash.delay);
          if Fighter_Crash.delay<20 then
             put_string_shadow(110,90,1,'G A M E  O V E R',lightred,red);

          if Fighter_Crash.delay>30 then Fighter_Crash.delay:=0;
     end;

end;


procedure fire_procedure;
var  i,j   : word;
begin
     if Game_Status<>Running then EXIT;
     Inc(count_fire);
     IF (Count_Fire>2) and (Count_Fire<10) Then Exit;
     IF Count_Fire>=10 Then begin Count_Fire:=0;  end;
     for i:=1 to 100 do
         IF NOT bomb[i].fly Then
            begin
                 bomb[i].fly:=true;
                 bomb[i].x:=x_statku+GetImgInfo(GameKit^.Fighters,which_fighter_sp)^.Fire.x1;
                 bomb[i].y:=y_statku+GetImgInfo(GameKit^.Fighters,which_fighter_sp)^.Fire.y1;
                 for j:=i to 100 do
                     IF NOT bomb[j].fly Then
                        begin
                             bomb[j].fly:=True;
                             bomb[j].x:=x_statku+GetImgInfo(GameKit^.Fighters,which_fighter_sp)^.Fire.x2;
                             bomb[j].y:=y_statku+GetImgInfo(GameKit^.Fighters,which_fighter_sp)^.Fire.y2;
                             break;
                        end;
                 break;
            end;
     if y_statku+GetFrame(GameKit^.Fighters,which_fighter_sp, which_fighter_fr)^.ymax<yk then Inc(y_statku);
end;



(*************************** Procedury M E N U ******************************)
Procedure New_Procedure;
begin
     Load_Levels;
     load_images(1,1);
     Game_Status:=Running;
end;

procedure Save_procedure;
begin
end;

procedure Open_procedure;
begin
end;

procedure Calibration_procedure;
begin
     Joy_Calibration(Configuration.Xcen,Configuration.Ycen,
     Configuration.XMin,Configuration.YMin,Configuration.XMax,Configuration.YMax);
end;

procedure Help_procedure;
const Ile_lini  = 15;
      text : array [1..ile_lini] of record
                                           x,y,fnt : word;
                                           txt     : string[60];
                                    end =
     ((x: 20;y: 10;fnt:3;txt:game_info1),
      (x:135;y: 10;fnt:4;txt:game_info2+', BY PIOTREK SKOWRONEK'),
      (x:202;y: 18;fnt:4;txt:game_info3),
      (x: 20;y: 35;fnt:4;txt:'Credits:    RADEK GEDZBA'),
      (x: 60;y: 43;fnt:4;txt:          '  PAWEL PROKOP'),
      (x: 60;y: 51;fnt:4;txt:          '  MAREK SKOWRONEK'),
      (x: 20;y:100;fnt:1;txt:'Controls:  Keyboard or Joystick'),
      (x: 20;y:110;fnt:1;txt:'    Arrows            : Movements'),
      (x: 20;y:120;fnt:1;txt:'    Ctrl-key,Spacebar : Fire'),
      (x: 20;y:130;fnt:1;txt:'    P,Pause           : Pause'),
      (x: 20;y:140;fnt:1;txt:'    Escape            : Menu'),
      (x: 20;y:150;fnt:1;txt:'    F1                : This page'),
      (x: 20;y:160;fnt:1;txt:'    F2                : Save game'),
      (x: 20;y:170;fnt:1;txt:'    F3                : Load game'),
      (x: 20;y:180;fnt:1;txt:'    F10,PrintScreen   : Screenshot'));
var   i: byte;
      TxtCol_1st,
      TxtCol_2nd : byte;

begin
      TxtCol_1st:= LightRed;
      TxtCol_2nd:= Red;

     s_virt:=SegA000;
     Clear_Events;
     pressed:=False;

     For i:=1 to ile_lini do
     put_string_shadow(text[i].x,text[i].y,text[i].fnt,text[i].txt,TxtCol_1st,TxtCol_2nd);

     Repeat Until Pressed;
     Clear_Events;
     s_virt:=Seg(virtual_screen^);
end;



procedure Quit_procedure;
var  ch   : word;
begin
     clear_keyboard;
     memW[$0:$417]:=0;                  { Wyzerowanie stanu specjalnych }
     s_virt:=SegA000;
     Restore_KeyBoard;
     put_string_shadow(117, 70,1,'Are you sure you',TxtCol_1st,TxtCol_2nd);
     put_string_shadow(115, 80,1,' wanna quit this',TxtCol_1st,TxtCol_2nd);
     put_string_shadow(115, 90,1,'  great game ?',TxtCol_1st,TxtCol_2nd);
     put_string_shadow(115,100,1,'     (Y/N)',TxtCol_1st,TxtCol_2nd);
repeat
     ch:=readkey;
until UpCase(Chr(ch)) in [#27,#13,'Y','N'];

IF UpCase(Chr(ch)) in ['Y',#13] Then begin fade_down; The_End; end;
     s_virt:=Seg(virtual_screen^);
     Set_Keyboard;                { Podczepienie mojej obsugi klawiatury }
end;


(****************************************************************************)
procedure Menu_procedure(pcor,p: P_Menu); { <- wsk. do menu }
const                   { ^ wsk. do wspdnych }
      znak = '';                                          { Znak opcji }
var   tlo  : T_BMP_Sprite;                      { Na cae to pod ramk }
      tym  : T_BMP_Sprite;                      { Na kursor }
      P_Tym: P_menu;                            { Pomocnicza }
      xp,yp,
      xk,yk,
      ypos : word;
      i    : word;
      Max  : word;
begin
     xp:=pcor^.xp;                  { Zaadowanie wspdnych ramki }
     yp:=pcor^.yp;
     xk:=pcor^.xk;
     yk:=pcor^.yk;
     ypos:=pcor^.ypos;
     Clear_Events;

     s_virt:=SegA000;
     Tlo.Data:=nil;
     Tym.Data:=nil;
     Get_BackGround(xp,yp,xk,yk,tlo);                     { Zap. caego ta }

                                                         { \/ Tytu menu \/ }
     put_string_shadow(xp+(xk-xp) shr 1-Length(Pcor^.Title)*9 shr 1, yp+5,1,Pcor^.Title,LightGreen,Green);
     P_Tym:=P;
     Max:=0;                                         { Ilo pozycji w menu }
     For i:=1 to $FFFF do
         begin
              inc(Max);                        { \/ Wyw. napisu pozycji \/ }
              put_string_shadow(xp+25, yp+10+Max*10,1,P_Tym^.Name,TxtCol_1st,TxtCol_2nd);
              IF (P_Tym^.What=Option) and         { Czy opcja ? i aktywna ? }
                 (mem[seg(P_Tym^.Where^):Ofs(P_Tym^.Where^)] and 1=1) then
                 put_string_shadow(xk-30, yp+10+Max*10,1,znak,TxtCol_1st,TxtCol_2nd);
              IF P_Tym^.Next=nil then break    { Jeli ona pusta to wyjcie }
                                 else P_Tym:=P_Tym^.Next; { Skok do nastpnej pozycji }
         end;

repeat
     Get_BackGround(xp,yp+09+ypos*10,xk,yp+09+ypos*10+10,tym);{ To cursora }
     Put_Block(xp,yp+12+ypos*10,xk,yp+15+ypos*10,Red);      { Linie cursora }
     Line(xp+1,yp+13+ypos*10,xk-2,yp+13+ypos*10,LightRed);
 {$IFDEF BETATEST}
     rectangle(xp,yp,xk-1,yk-1,lightred);
 {$ENDIF}
     P_Tym:=P;
     For i:=1 to Ypos-1 do P_Tym:=P_Tym^.Next;    { Zdoby wskanik pozycji }
     put_string_shadow(xp+25,ypos*10+yp+10,1,P_Tym^.Name,white,black);
     IF (P_Tym^.What=Option) and                  { Czy opcja ? i aktywna ? }
        (mem[seg(P_Tym^.Where^):Ofs(P_Tym^.Where^)] and 1=1) then
        put_string_shadow(xk-30, yp+10+Ypos*10,1,znak,White,Black);

     repeat until pressed;                      { Wyczekiwanie na zdarzenie }

     IF pressed Then
        begin
             IF MENU  Then break;
             IF ENTER Then break;

             put_image(xp,yp+09+ypos*10,tym);    { Podstawienie starego ta }

             If DOWN Then begin IF ypos<MAX Then Inc(ypos)
                                            Else ypos:=1;    end;
             If UP   Then begin IF ypos>1 Then Dec(ypos)
                                          Else ypos:=MAX;    end;
             pressed:=False;
             UP:=False;
             DOWN:=False;
        end;

until False;

     put_image(xp,yp,tlo);              { Odtworzenie caego ta z pod menu }
     Release_Sprite(Tlo);               { Zwolnienie pamici }
     Release_Sprite(Tym);

     s_virt:=Seg(virtual_screen^);
     IF MENU Then begin while MENU do; Exit; end;
     Clear_Events;
     pcor^.ypos:=ypos;                     { Zap. ostatniej pozycji kursora }

                        (*** Wykonanie zadania ***)
     P_Tym:=P;
     For i:=1 to Ypos-1 do P_Tym:=P_Tym^.Next;   { Pobr. wsk. gdzie wykona }
     case P_Tym^.What of
        SubMenu   : IF P_Tym^.Where<>nil Then Menu_Procedure(P_Tym,P_Tym^.Where);
        Operation : IF @P_Tym^.Call<>nil Then P_Tym^.Call;
        Option    : begin
                       Config_Changed:=True;
                       IF P_Tym^.Where<>nil Then mem[seg(P_Tym^.Where^):Ofs(P_Tym^.Where^)]:=
                                                (NOT mem[seg(P_Tym^.Where^):Ofs(P_Tym^.Where^)]) and 1;
                    end;
     end;
end;




(****************************************************************************)
Procedure Menu_Init;             { Inicjacja tablic z menu }

Function NewMenu(name,title: string; xp,yp,xk,yk,ypos: word; where: P_Menu; next: P_Menu): pointer;
var  p: P_Menu;
begin
     new(p);
     p^.Title:=Title;
     p^.Name:=Name;
     p^.xp:=xp;
     p^.yp:=yp;
     p^.xk:=xk;
     p^.yk:=yk;
     p^.ypos:=ypos;
     p^.Where:=Where;
     p^.Call:=nil;
     p^.Next:=Next;
     p^.What:=SubMenu;
     NewMenu:=p;
end;

Function NewItem(name: string; Call: Pointer; next: P_Menu): pointer;
var  p: P_Menu;
begin
     new(p);
     p^.Name:=Name;
     @p^.Call:=Call;
     p^.Where:=nil;
     p^.Next:=Next;
     p^.What:=Operation;
     NewItem:=p
end;

Function NewOption(name: string; where: Pointer; next: P_Menu): pointer;
var  p: P_Menu;
begin
     new(p);
     p^.Name:=Name;
     p^.Where:=Where;
     p^.Next:=Next;
     p^.What:=Option;
     p^.Call:=nil;
     NewOption:=p
end;

begin
     Menu_Tab:=NewMenu('Main menu','Main menu',95,41,250,122,1,nil,
                  NewMenu('N E W','Choose skill level:',67,41,275,95,1,
                     NewItem('I''m too young to die',@New_Procedure,
                     NewItem('Let''s clean-up',@New_Procedure,
                     NewItem('I''m the undefeated',@New_Procedure,nil))),
                  NewItem('L O A D',@Open_Procedure,
                  NewItem('S A V E',@Save_Procedure,
                  NewMenu('O P T I O N S','OPTIONS',95,41,250,102,1,
                     NewOption('SFX',@Configuration.SFX,
                     NewOption('MUSIC',@Configuration.MUSIC,
                     NewOption('JOYSTICK',@Configuration.JOY,
                     NewItem('CALIBRATION',@Calibration_procedure,nil)))),
                  NewItem('H E L P',@Help_Procedure,
                  NewItem('Q U I T',@Quit_Procedure,nil)))))));
end;




(****************************************************************************)
procedure Check4Event;
begin
IF Up Then
   begin
        if integer(y_statku-step_y)>=(yp)
           then dec(y_statku,step_y)
           else y_statku:=0;
   end;
IF Down Then
   begin
        if y_statku+GetFrame(GameKit^.Fighters,which_fighter_sp, which_fighter_fr)^.ymax+step_y<yk
           then Inc(y_statku,step_y)
           else y_statku:=yk-GetFrame(GameKit^.Fighters,which_fighter_sp, which_fighter_fr)^.ymax-1;
   end;
IF Left Then
   begin
        if integer(x_statku-step_x)>xp
           then dec(x_statku,step_x)
           else x_statku:=xp;
   end;
IF Right Then
   begin
        if x_statku+GetFrame(GameKit^.Fighters,which_fighter_sp, which_fighter_fr)^.xmax+step_x<xk
           then Inc(x_statku,step_x)
           else x_statku:=xk-GetFrame(GameKit^.Fighters,which_fighter_sp, which_fighter_fr)^.xmax-1;
   end;
IF Menu  Then Menu_procedure(Menu_Tab,Menu_Tab^.Next);
IF Help  Then Help_procedure;
IF Pause Then begin s_virt:=SegA000;
                    put_string_shadow(xp+30,yp+70,3,'P  A  U  S  E',TxtCol_1st,TxtCol_2nd);
                    while Pause do;
                    while NOT Pause do;
                    while Pause do;
                    s_virt:=Seg(virtual_screen^);
              end;
IF Fire  Then fire_procedure;
IF Print Then begin s_virt:=SegA000;
                    corner_status:='Writing screenshot... ';
                    Write_Corner_Status(corner_status);
                    IF Drop_The_Screen Then corner_status:=corner_status+'DONE.'
                                       Else corner_status:=corner_status+'FAILED!';
                    s_virt:=Seg(virtual_screen^);
              end;

IF Beta Then
   begin
        Beta_Test:=NOT Beta_Test;
        IF Beta_Test Then corner_status:='BETA-MODE'
                     Else corner_status:='NORMAL';
        Beta:=False;
   end;
end;

(****************************************************************************)


procedure Check4JOYEvent;
var   stan : byte;
      x,y  : word;
      joy_sens1 : word;
      joy_sens2 : word;
      joy_sens3 : word;
      joy_sens4 : word;
begin
     IF NOT Configuration.JOY Then EXIT;
     Get_Joy_XY_Direct(x,y);
     Get_Joy_Status_Direct(stan);
     IF stan and 16<>16 Then Fire:=True       { Jedynka tzn e #1 relesed }
                        Else
     begin
     IF stan and 32=32 Then Fire:=False       { Button #2 }
                       Else Fire:=True;
     end;

     joy_sens1:=(Configuration.Xcen shr 1);
     IF x<joy_sens1 Then begin Left:=True; Right:=False; end;
     joy_sens2:=Configuration.Xcen+(Configuration.Xmax-Configuration.Xcen) shr 1 - Configuration.XMin;
     IF x>joy_sens2 Then begin Right:=True; Left:=False; end;
     joy_sens3:=(Configuration.Ycen shr 1);
     IF y<joy_sens3 Then begin Up:=True; Down:=False; end;
     joy_sens4:=Configuration.Ycen+ (Configuration.Ymax-Configuration.Ycen) shr 1 -Configuration.YMin;
     IF y>joy_sens4 Then begin Down:=True; Up:=False; end;
     IF Is_In_Rectangle(x,y,joy_sens1,joy_sens3,joy_sens2,joy_sens4) then
        begin Left:=False; Right:=False; Up:=False; Down:=False; end;
end;



(******************************  M * A * I * N  *****************************)
begin
Mark(HEAP_state);
init_procedures;
Check_processor;
initgraph256;                       { Init 320x200x256 }
s_virt:=SegA000;
put_string_shadow(50,95,1,Wait_MSG,15,2);
s_virt:=seg(virtual_screen^);
Menu_Init;                                           { Init menu w mem }

Mark(Free_HEAP);
Load_Levels;
Load_Images(1,1);

move_data;

REPEAT
Check4JoyEvent;                                      { Obsuga Joystick'a }
Check4Event;                                         { Obsuga zdarze    }

Move_BackGround(@GameKit^.Scene^.image^.img);        { Przesunicie ta   }
UpDate_Bombs;
UpDate_Alians;
UpDate_Fighter;
UpDate_Values;
Write_Corner_Status(Corner_Status);      { Taki napis-status jak w DOOMie }
Move_Data;                               { Podoenie nowej klatki }
inc(Screen_Pos);
inc(frame);                              { Tylko statystyka klatek/sec }
UNTIL FALSE;

The_End;
end.



{ karen allen jako jenny heyden w starman }