(*
        SpaceSweeper helper 
        Keyboard helper, mainly in asm written. Thanks to this
        we may not use CRT;     

        Author: Piotr Skowronek, pskowronek@adfinem.net
        Written in: 1997
        Licence: LGPL
 *)

Unit KEYBOARD;      { Dostosowany do GRY - Space Sweeper }
interface
uses DOS;

procedure Restore_Keyboard; (*** Obsuga "direct" przerwania klawiatury ***)
procedure Set_Keyboard;
procedure Clear_Events;

function  ReadKey:word;     (*** Obsuga klawiatury via BIOS 's INT 16h ***)
function  KeyPressed:boolean;
procedure Clear_KeyBoard;
procedure Set_Max_Speed;

Const
(****************** Klawiatura ******************)
     right      :  boolean = false;   { Uaktualniane przez KEYBOARD_HANDLER }
     up         :  boolean = false;
     down       :  boolean = false;
     left       :  boolean = false;
     fire       :  boolean = false;
     pause      :  boolean = false;
     help       :  boolean = false;
     menu       :  boolean = false;
     enter      :  boolean = false;
     print      :  boolean = false;
     beta       :  boolean = false;

     count_right  :  word = 0;          { Ile powtrze key'a do unpress }
     count_up     :  word = 0;
     count_down   :  word = 0;
     count_left   :  word = 0;
     count_fire   :  word = 0;
     count_pause  :  word = 0;
     count_help   :  word = 0;
     count_menu   :  word = 0;
     count_enter  :  word = 0;
     count_print  :  word = 0;
     count_beta   :  word = 0;

     pressed      :  boolean = false;   { Is something pressed ? }

implementation
Type
     P_Bool     = ^boolean;
     P_Word     = ^word;
     scan       = record  pressed   : P_Bool;   { Ktrej zmiennej uy }
                          count     : P_Word;   { Ktr zmienn INC    }
                          max       : byte;     { Max. byte'w na znak }
                          codes     : array[1..6] of byte; { ScanCode  }
                          codes_out : array[1..6] of byte; { BreakCode }
                  end;

Const
     Max_Keys     =  14;                { Liczba rozpoznawanych klawiszy }
     (******* Scan Codes ********)
     scan_code    :  array [1..Max_Keys] of scan =       { Kody klawiszy }
((pressed: @right; count: @count_right; max:1; codes:($4d,0,0,0,0,0); codes_out:($4d+$80,0,0,0,0,0)),
 (pressed: @up;    count: @count_up;    max:1; codes:($48,0,0,0,0,0); codes_out:($48+$80,0,0,0,0,0)),
 (pressed: @down;  count: @count_down;  max:1; codes:($50,0,0,0,0,0); codes_out:($50+$80,0,0,0,0,0)),
 (pressed: @left;  count: @count_left;  max:1; codes:($4b,0,0,0,0,0); codes_out:($4b+$80,0,0,0,0,0)),
 (pressed: @fire;  count: @count_fire;  max:1; codes:($1d,0,0,0,0,0); codes_out:($1d+$80,0,0,0,0,0)),
 (pressed: @fire;  count: @count_fire;  max:1; codes:($39,0,0,0,0,0); codes_out:($39+$80,0,0,0,0,0)),
 (pressed: @pause; count: @count_pause; max:1; codes:($45,0,0,0,0,0); codes_out:($45+$80,0,0,0,0,0)),
 (pressed: @pause; count: @count_pause; max:1; codes:($19,0,0,0,0,0); codes_out:($19+$80,0,0,0,0,0)),
 (pressed: @help;  count: @count_help;  max:1; codes:($3b,0,0,0,0,0); codes_out:($3b+$80,0,0,0,0,0)),
 (pressed: @menu;  count: @count_menu;  max:1; codes:($01,0,0,0,0,0); codes_out:($01+$80,0,0,0,0,0)),
 (pressed: @enter; count: @count_enter; max:1; codes:($1c,0,0,0,0,0); codes_out:($1c+$80,0,0,0,0,0)),
 (pressed: @print; count: @count_print; max:1; codes:($37,0,0,0,0,0); codes_out:($37+$80,0,0,0,0,0)),
 (pressed: @print; count: @count_print; max:1; codes:($44,0,0,0,0,0); codes_out:($44+$80,0,0,0,0,0)),
 (pressed: @beta;  count: @count_beta;  max:1; codes:($52,0,0,0,0,0); codes_out:($52+$80,0,0,0,0,0))
 );

Var     old_int09       : pointer;


{$F+}
procedure keyboard_handler; interrupt;      { Obsuga "direct" }
const kody      :  array [1..10] of byte = (0,0,0,0,0,0,0,0,0,0);
      ile_kodow : byte = 0;
type  T_status  = (miss,hit);
var   kod   :  byte;
      i,q   :  byte;
      status:  T_status;
      tym   :  boolean;
begin
asm
      cli
      in     al,60h      { Odczyt z portu scan-code'u }
      mov    kod,al
      in     al,61h      { Jaka chyba dziwna odpowied na odebranie }
      or     al,80h
      out    61h,al
      and    al,7Fh
      out    61h,al
end;

IF ile_kodow>6 then ile_kodow:=1
               else inc(ile_kodow);

kody[ile_kodow]:=kod;


status:=miss;

for  i:=1 to max_keys do
     begin
          IF scan_code[i].codes[1]=kody[1] then status:=hit;
          IF scan_code[i].codes_out[1]=kody[1] then status:=hit;
     end;

IF status=miss Then
begin
             ile_kodow:=0;
             fillchar(kody,sizeof(kody),0);
             asm
                mov    al,20h      { EOI }
                out    20h,al
                sti
             end;
             exit;
end;

IF (kody[ile_kodow]=$aa) and (kody[ile_kodow-1]=$e0) Then { Numlock errors preventer }
   begin kody[ile_kodow]:=0;
         kody[ile_kodow-1]:=0;
   end;
IF (kody[1]=$e0) and (kody[2]=$2a) Then           { Numlock errors preventer }
   begin For i:=3 to ile_kodow do kody[i-2]:=kody[i];
         dec(ile_kodow,2);
   end;

status:=miss;
for  i:=1 to max_keys do
     begin
          tym:=false;
          for q:=1 to scan_code[i].max do
              IF scan_code[i].codes[q]<>kody[q] then tym:=true;
          IF tym=false Then
             begin                                    { \/ True na zdarzeniu }
                  mem[Seg(scan_code[i].pressed^):ofs(scan_code[i].pressed^)]:=1;
                  Inc(mem[Seg(scan_code[i].count^):ofs(scan_code[i].count^)]);
                  pressed:=true;
                  ile_kodow:=0;
                  fillchar(kody,sizeof(kody),0);
                  status:=hit;
                  break;
             end;
     end;


     IF status=hit then
        begin
             asm
                mov    al,20h      { EOI }
                out    20h,al
                sti
             end;
             exit;
        end;

     IF (kody[1]=$e0) and (kody[2]=$aa) then
        begin
             ile_kodow:=0;
             fillchar(kody,sizeof(kody),0);
             asm
                mov    al,20h      { EOI }
                out    20h,al
                sti
             end;
             exit;
        end;

for i:=1 to max_keys do
    begin
         tym:=false;
         for q:=1 to scan_code[i].max do
             IF scan_code[i].codes_out[q]<>kody[q] then tym:=true;
         IF tym=false Then
            begin
                 status:=hit;                       { \/ False na zdarzeniu }
                 mem[Seg(scan_code[i].pressed^):ofs(scan_code[i].pressed^)]:=0;
                 mem[Seg(scan_code[i].count^):ofs(scan_code[i].count^)]:=0;
                 pressed:=false;
                 ile_kodow:=0;
                 fillchar(kody,sizeof(kody),0);
                 break;
            end;
    end;

asm
      mov    al,20h      { EOI }
      out    20h,al
      sti
end;
end;
{$F-}

procedure Set_KeyBoard;                 { Ustawi adres obsugi i zap. stary }
var  check : pointer;
begin
     GetIntVec($09,Check);
     IF Check=@Keyboard_Handler Then EXIT;   { Aby nie podczepia dwa razy }
     Old_INT09:=Check;
     SetIntVec($09,@Keyboard_Handler);
end;

procedure Restore_KeyBoard;             { Przywraca oryginaln obsug }
begin
     IF Old_INT09=nil Then EXIT;        { Something's wrong ? }
     SetIntVec($09,Old_INT09);
end;

procedure Clear_Events;                 { Waits for unpress all known keys }
begin                                   { (Wait to end almost all events)  }
     while Enter do;
     while Help  do;
     while Fire  do;
     while Menu  do;
     Pressed:=False;
end;
(******* Koniec procedur do bezporedniej obsugi *******)



(******* Obsuga klawiatury przez BIOS 's INT 16h *******)
Function ReadKey: word; assembler;
asm
        mov     ah,0h
        int     16h
end;

Function KeyPressed: Boolean; assembler;
asm
        mov     ah,11h
        int     16h
        jnz     @Pressed
        xor     ax,ax

        jmp     @koniec

@Pressed:
        mov     ax,1

@koniec:
end;


procedure clear_keyboard; assembler;
asm
@Czysc:
        mov     ah,11h              { IS keypressed ? }
        int     16h
        jz      @koniec

        mov     ah,10h              { Pressed }
        int     16h
        loop    @Czysc

@koniec:
end;

procedure Set_max_speed; assembler;
asm
(*        jmp     @dalej

@zajety:
        in      al,64h
        and     al,2
        cmp     al,2
        jz      @zajety
ret

@dalej:
        cli
        call    @zajety
        mov     al,0f3h            { Set kb speed }
        out     60h,al

        call    @zajety            { Set max speed }
        xor     al,al
        out     60h,al
        sti*)

        mov     ah,03h
        xor     bx,bx
        int     16h
end;

end.