(*
        SpaceSweeper helper 
        Loads game.dat - compilled game resource file

        Author: Piotr Skowronek, pskowronek@adfinem.net
        Written in: 1997
        Licence: LGPL
 *)

Unit READDAT;      { Dostosowany do GRY - Space Sweeper }
{$I+,R-,G+,S+,D+,Q-,V-,B-}
interface          { DAT reading }
uses DOS,STRINGS,TYPES,MISC;


(*** Odczyt DATw ***)
procedure ReadKit(name: string; which_kit: byte; var Kit : P_Kit);
procedure DisposeKit(var Kit: P_Kit);      { Zwalnia pami KITa }
procedure DelBranche(var pos: p_images);   { Zwalnia tylko odnog }

procedure OpenResource(var f: file; name: string);
procedure ReadResourceHeader(var f: file; head: p_resource);

function  ReadLevel(name: string; which_epi, which_lev: word): pointer;
function  ReadEpisode(name: string; which_epi: word): pointer;
function  ReadIntro(name: string; which_epi,which_lev: word): p_intro;
procedure DisposeIntro(var p_int: p_intro);     { Zwalnia pami dla intra }
procedure DisposeLevel(var P_Lev: P_Levels);    { Zwalnia pami level'owi }
procedure DisposeAllLevels(var P_Lev: P_Levels);

function  ReadSprite(name: string; pos: longint): p_bmp_sprite;

function  GetMaxKits(name: string): word;       { Ilo zestaww }
function  GetMaxEpisodes(name: string): word;   { Ilo Episodw }
function  GetMaxLevels(name: string; which_epi: word): word;  { Ilo Leveli }
function  GetMaxShips(P_Lev: P_Levels): word;   { Ilo statkw w level'u }
function  GetMaxSprite(P_Ima: P_Images): word;  { Ilo odp sprite'w w KIT }
function  GetMaxFrame(P_Ima: P_Images; which_sprite: word): word;
function  GetFrame(P_Ima: P_Images; which_sprite, which_frame: word): P_BMP_Sprite;
function  GetImgInfo(P_Ima: P_Images; which_sprite: word): P_Images;
function  GetShipPos(Epi: P_Episodes; which_epi,which_lev,which_shi: word): P_ShipsPos;
function  LastShipPos(Epi: P_Episodes; var which_epi,which_lev: word): P_ShipsPos;
procedure DisposeShipPos(Epi: P_Episodes; which_epi,which_lev,which_shi: word); { Zwalnia pami statkowi }
function  GetEpisodePoint(Epi: P_Episodes; which_epi: word): P_Episodes;
procedure Reserve4Episode(Epi: P_Episodes; which_epi: word);
function  GetLevelPoint(Epi: P_Episodes; which_epi,which_lev: word): P_Levels;
procedure Reserve4level(Epi: P_Episodes; which_epi,which_lev: word);

procedure SetColors(Kit: P_Kit);           { Ust. palet i numery 16 kolorom }



implementation


(****************************************************************************
 **************************  * Do odczytu DATw *  **************************
 ****************************************************************************)
procedure ReadKit(name: string; which_kit: byte; var Kit : P_Kit);
                                            { Odczytuje cay KIT do pamici }
function ReadBranche(var f: file; pos: longint): p_images;
var   p_branche : p_images;
      t_branche : t_images;
      p_sub     : p_image;
      t_sub     : t_image;
begin
     new(p_branche);
     ReadBranche:=p_branche;
     seek(f,pos);
repeat
     BlockRead(f,t_branche,SizeOf(t_images));
     p_branche^:=t_branche;
     New(p_sub);
     p_branche^.image:=p_sub;

     Seek(f,Longint(t_branche.image));       { Odczyt "Sub katalogu" }
     BlockRead(f,t_sub,SizeOf(t_sub));

     repeat
     p_sub^:=t_sub;
     If t_sub.img.pal_exist Then          { Odczyt palety jeli jest }
     begin
          seek(f,Longint(t_sub.img.pal));
          p_sub^.img.pal:=Reserve_Mem(3*256);
          BlockRead(f,p_sub^.img.pal^,3*256);
     end;

     p_sub^.img.data:=reserve_mem(t_sub.img.size);
     seek(f,Longint(t_sub.img.data));          { Odczyt ciaa bitmap }
     BlockRead(f,p_sub^.img.data^,t_sub.img.size);

     if t_sub.next=nil Then
        begin
             p_sub^.next:=nil;
             break;
        end;

     p_sub^.next:=reserve_mem(sizeof(t_image));
     p_sub:=p_sub^.next;
     Seek(f,Longint(t_sub.next));            { Odczyt "Sub katalogu" }
     BlockRead(f,t_sub,SizeOf(t_sub));

     until false;

     if t_branche.next = nil Then
        begin
             p_branche^.next:=nil;
             break;
        end;
     seek(f,longint(t_branche.next));
     p_branche^.next:=reserve_mem(sizeof(t_branche));
     p_branche:=p_branche^.next;
until false;
end;

var  Head : T_Resource;
     PKit : P_Kit;
     f    : file;
     i    : byte;
begin
     if kit=nil then New(Kit);
     filemode:=0;
     assign(f,name);
     reset(f,1);
     Check4Error(name);
     blockread(f,Head,SizeOf(Head));
     If NOT StrCmp(@Head.Head.ID,ID) Then
        WriteExitMsg('Incorrect bitmap resource. File name: '+name);
     if Head.ImageKit=nil Then
        WriteExitMsg('Images not found in resource.');
     PKit:=Head.ImageKit;
     for i:=1 to which_kit do
     begin
          seek(f,Longint(Pkit));
          blockread(f,kit^,sizeof(T_Kit));
          if kit^.Next = nil then break;
          pkit:=kit^.next;
     end;
     Kit^.Alians:=ReadBranche(f,Longint(Kit^.Alians));
     Kit^.Explodes:=ReadBranche(f,Longint(Kit^.Explodes));
     Kit^.Fighters:=ReadBranche(f,Longint(Kit^.Fighters));
     Kit^.Cockpit:=ReadBranche(f,Longint(Kit^.Cockpit));
     Kit^.Scene:=ReadBranche(f,Longint(Kit^.Scene));
     Kit^.Colors:=ReadBranche(f,Longint(Kit^.Colors));
     close(f);
end;


procedure DelBranche(var pos: p_images);       { Wymazuje tylko jedn ga }
var   p_branche : p_images;
      p_sub     : p_image;
      p_next    : p_image;
begin
repeat
     p_sub:=pos^.image;
     p_branche:=pos^.next;
     if pos=nil then exit;
     dispose(pos);
     if p_sub<> nil then
     repeat
           p_next:=p_sub^.next;
           If p_sub^.img.pal_exist Then FreeM(p_sub^.img.pal,3*256);
           FreeM(p_sub^.img.data,p_sub^.img.size);
           dispose(p_sub);
           if p_next = nil then break;
           p_sub:=p_next;
     until false;

     pos:=p_branche;
     if pos = nil then break;
until false;
     pos:=nil;
end;

procedure DisposeKit(var Kit : P_Kit);    { Zwalnia ca pami dla zestawu }
begin
     DelBranche(Kit^.Alians);
     DelBranche(Kit^.Explodes);
     DelBranche(Kit^.Fighters);
     DelBranche(Kit^.Cockpit);
     DelBranche(Kit^.Scene);
     DelBranche(Kit^.Colors);
end;



procedure SetColors(Kit : P_Kit); { Ustawia palet i odpowiednie kolory }
var  pos: word;
begin
     pos:=Kit^.Colors^.image^.img.size-Kit^.Colors^.image^.img.xmax;
     Black:=Kit^.Colors^.image^.img.data^[pos+1];
     Blue:=Kit^.Colors^.image^.img.data^[pos+2];
     Green:=Kit^.Colors^.image^.img.data^[pos+3];
     Cyan:=Kit^.Colors^.image^.img.data^[pos+4];
     Red:=Kit^.Colors^.image^.img.data^[pos+5];
     Magenta:=Kit^.Colors^.image^.img.data^[pos+6];
     Brown:=Kit^.Colors^.image^.img.data^[pos+7];
     LightGray:=Kit^.Colors^.image^.img.data^[pos+8];
     DarkGray:=Kit^.Colors^.image^.img.data^[pos+9];
     LightBlue:=Kit^.Colors^.image^.img.data^[pos+10];
     LightGreen:=Kit^.Colors^.image^.img.data^[pos+11];
     LightCyan:=Kit^.Colors^.image^.img.data^[pos+12];
     LightRed:=Kit^.Colors^.image^.img.data^[pos+13];
     LightMagenta:=Kit^.Colors^.image^.img.data^[pos+14];
     Yellow:=Kit^.Colors^.image^.img.data^[pos+15];
     White:=Kit^.Colors^.image^.img.data^[pos+16];

     TxtCol_1st:=LightRed;
     TxtCol_2nd:=Red;

     IF NOT Kit^.Colors^.Image^.Img.Pal_Exist Then
        WriteExitMsg('Palette not found in resource.');

     SetRGBpal(Seg(Kit^.Colors^.Image^.Img.pal^),
               Ofs(Kit^.Colors^.Image^.Img.pal^));
end;




(****************** R E A D I N G ********************)
procedure OpenResource(var f: file; name: string);
begin                             { Open for reading }
     filemode:=0;
     assign(f,name);
     reset(f,1);
     Check4Error(name);
end;

procedure ReadResourceHeader(var f: file; head: p_resource);
begin
     if head=nil then WriteExitMsg('Null assignment.');
     seek(f,0);
     blockread(f,head^,sizeof(T_resource));
     Check4Error(GetFName(f));
end;

function SeekEpisode(var f: file; pos: longint; which_epi: word; Epi: P_Episodes): word;
var  i : word;
begin
     seek(f,pos);
     for i:=1 to which_epi do
     begin
          SeekEpisode:=i;
          blockread(f,Epi^,SizeOf(T_Episodes));
          Check4Error(GetFName(f));
          if i = which_epi then break;
          seek(f,longint(Epi^.Next));
          if Epi^.Next = nil then break;
     end;
end;

function SeekLevel(var f: file; pos: longint; which_lev: word; Lev: P_Levels): word;
var  i: word;
begin
     seek(f,pos);
for i:=1 to which_lev do
begin
     SeekLevel:=i;
     blockread(f,Lev^,Sizeof(T_Levels));
     Check4Error(GetFName(f));
     if i = which_lev then break;
     if Lev^.Next = nil then break;
     seek(f,longint(Lev^.Next));
end;
end;



(******************** R E A D I N G *******************)
function  GetMaxKits(name: string): word;
var  head  : T_Resource;
     kit   : T_Kit;
     p     : P_Kit;
     f     : file;
     count : word;
begin
     OpenResource(f,name);
     ReadResourceHeader(f,@head);
     count:=0;

     if head.Imagekit = nil then WriteExitMsg('Image kit not found.');
     p:=head.ImageKit;
repeat
     inc(count);
     seek(f,longint(p));
     blockread(f,kit,sizeof(kit));
     check4error(name);
     if kit.next = nil then break;
     p:=kit.next;
until false;

     GetMaxKits:=count;
     close(F);
end;


function GetMaxEpisodes(name: string): word;
var  head  : T_Resource;
     Epi   : T_Episodes;
     f     : file;
begin
     OpenResource(f,name);
     ReadResourceHeader(f,@head);

     if head.episodes = nil then
        begin GetMaxEpisodes:=0; close(f); exit; end;

     GetMaxEpisodes:=SeekEpisode(f,longint(head.Episodes),$FFFF,@Epi);
     close(F);
end;


function GetMaxLevels(name: string; which_epi: word): word;
var  head  : T_Resource;
     Epi   : T_Episodes;
     Lev   : T_Levels;
     f     : file;
begin
     OpenResource(f,name);
     ReadResourceHeader(f,@head);

     if head.episodes = nil then
        begin GetMaxLevels:=0; close(f); exit; end;

     SeekEpisode(f,longint(head.Episodes),which_epi,@Epi);

     if Epi.Levels = nil then WriteExitMsg('Episode does not contain levels.');

     GetMaxLevels:=SeekLevel(f,longint(Epi.Levels),$FFFF,@Lev);
     close(F);
end;


function GetMaxShips(P_Lev: P_Levels): word;
var  Count : word;
     P_Shi : P_ShipsPos;
     i     : word;
begin
     if P_Lev = nil then WriteExitMsg('Null assignment');
     count:=0;
     P_Shi:=P_Lev^.ShipsPos;
     if P_Shi = nil then WriteExitMsg('Null assignment');
repeat
     inc(count);
     if P_Shi^.Next = nil then break;
     P_Shi:=P_Shi^.Next;
until false;
     GetMaxShips:=Count;
end;

function  GetMaxSprite(P_Ima: P_Images): word;
var  i     : word;
begin
     for i:=1 to $FFFF do
     begin
          GetMaxSprite:=i;
          if P_Ima^.Next=nil then break;
          P_Ima:=P_Ima^.Next;
     end;
end;




function ReadSprite(name: string; pos: longint): p_bmp_sprite;
var  f : file;
     p : p_bmp_sprite;
begin
     filemode:=0;
     assign(f,name);
     reset(f,1);
     p:=reserve_mem(sizeof(T_BMP_Sprite));
     ReadSprite:=p;

     seek(f,pos);
     blockread(f,p^,sizeof(t_bmp_sprite));
     check4error(name);

     if p^.pal_exist then
        begin
             seek(f,longint(p^.pal));
             p^.pal:=reserve_mem(3*256);
             blockread(f,p^.pal^,3*256);
        end;

     seek(f,longint(p^.data));
     p^.data:=reserve_mem(p^.size);
     blockread(f,p^.data,p^.size);
     check4error(name);
     close(F)
end;

function ReadIntroFromDisk(name: string; pos: longint): p_intro;
var  f     : file;
     P_Int : P_Intro;
     P_Img : P_Image;

begin
     filemode:=0;
     assign(f,name);
     reset(f,1);
     Check4Error(name);

     p_int:=reserve_mem(SizeOf(T_Intro));
     ReadIntroFromDisk:=p_int;

     seek(f,pos);
     blockread(f,p_int^,sizeof(t_intro));
     if p_int^.text <> nil then       { Czy zawiera text ? }
        begin
             seek(f,longint(p_int^.text));
             p_int^.text:=reserve_mem(p_int^.size);
             blockread(f,p_int^.text^,p_int^.size);
        end;
     If p_int^.image <> nil then      { Czy zawiera image ? }
        begin
             seek(f,longint(p_int^.image));
             p_img:=reserve_mem(sizeof(T_image));
             p_int^.image:=p_img;
             blockread(f,p_img^,sizeof(T_image));
             p_img^.img:=ReadSprite(name,longint(p_img))^;
        end;
     close(f);
end;


function ReadIntro(name: string; which_epi,which_lev: word): p_intro;
              { if which_lev=0 then read episode intro }
var  f    : file;
     head : T_Resource;
     Epi  : T_Episodes;
     Lev  : T_Levels;
begin
     OpenResource(f,name);
     ReadResourceHeader(f,@head);

     if head.episodes = nil then WriteExitMsg('File: ['+name+'] does not contain episodes.');

     if SeekEpisode(f,longint(head.Episodes),which_epi,@epi)<>which_epi then
        WriteExitMsg('Episode DO NOT exist.');

     if which_lev = 0 then
        begin
             close(f);
             ReadIntro:=ReadIntroFromDisk(name,longint(Epi.Intro));
             exit;
        end;

     if SeekEpisode(f,longint(Epi.Levels),which_lev,@lev)<>which_lev then
        WriteExitMsg('Level not exist in episode.');;

     close(f);
     ReadIntro:=ReadIntroFromDisk(name,longint(Lev.intro));
end;


function ReadLevel(name: string; which_epi,which_lev: word): pointer;
var  head  : T_Resource;
     Epi   : T_Episodes;
     Lev   : T_Levels;
     P_Lev : P_Levels;
     P_Shi : P_ShipsPos;
     f     : file;

begin
     OpenResource(f,name);
     ReadResourceHeader(f,@head);

     if head.episodes = nil then WriteExitMsg('File: ['+name+'] does not contain episodes.');

     if SeekEpisode(f,longint(head.Episodes),which_epi,@epi)<>which_epi then
        WriteExitMsg('Episode DO NOT exist.');

     if Epi.Levels = nil then WriteExitMsg('Episode does not contain levels.');

     if SeekLevel(f,longint(Epi.Levels),which_lev,@lev)<>which_lev then
        WriteExitMsg('Level not exist in episode.');

     p_lev:=reserve_mem(sizeof(lev));
     ReadLevel:=p_lev;              { Function returns entry to level }
     p_lev^:=lev;

     p_shi:=reserve_mem(sizeof(T_ShipsPos));
     seek(f,longint(p_lev^.ShipsPos));
     if p_lev^.ShipsPos = nil then WriteExitMsg('Level DOES NOT contain ships positions.');
     p_lev^.ShipsPos:=p_shi;

repeat                              { Czyta pozycje statkw z level'a }
     blockread(f,p_shi^,sizeof(T_ShipsPos));
     Check4Error(name);

     if p_shi^.next=nil then break;
     seek(f,longint(p_shi^.next));
     p_shi^.next:=reserve_mem(sizeof(T_ShipsPos));
     p_shi:=p_shi^.next;
until false;

     p_lev^.intro:=nil;             { Funkcja nie aduje intra }
     close(F);
     check4error(name);
end;


function  ReadEpisode(name: string; which_epi: word): pointer;
var  head  : T_Resource;
     Epi   : T_Episodes;
     P_epi : P_Episodes;
     i     : word;
     f     : file;
begin
     OpenResource(f,name);
     ReadResourceHeader(f,@head);

     if head.episodes = nil then WriteExitMsg('File: ['+name+'] does not contain episodes.');

     if SeekEpisode(f,longint(head.Episodes),which_epi,@epi)<>which_epi then
        WriteExitMsg('Episode DO NOT exist.');

     p_epi:=reserve_mem(sizeof(T_episodes));
     ReadEpisode:=p_epi;
     p_epi^:=epi;

     p_epi^.levels:=nil;              { Czyta tylko episod-info nie levele }
     p_epi^.intro:=nil;               { Czyta tylko episod-info nie intro  }

     close(F);
end;

function  GetFrame(P_Ima: P_Images; which_sprite, which_frame: word): P_BMP_Sprite;
var  i     : word;
     P_Img : P_Image;
begin

     for i:=1 to which_sprite do
     begin
          if i=which_sprite then break;
          if P_Ima^.Next=nil then WriteExitMsg('Sprite not found.');
          P_Ima:=P_Ima^.Next;
     end;

     P_Img:=P_Ima^.image;

     for i:=1 to which_frame do
     begin
          if i=which_frame then break;
          if P_Img^.Next=nil then WriteExitMsg('Frame in sprite not found.');
          P_Img:=P_Img^.Next;
     end;

     GetFrame:=@P_Img^.Img;
end;


function  GetImgInfo(P_Ima: P_Images; which_sprite: word): P_Images;
var  i     : word;
     P_Img : P_Image;
begin

     for i:=1 to which_sprite do
     begin
          if i=which_sprite then break;
          if P_Ima^.Next=nil then WriteExitMsg('Sprite not found.');
          P_Ima:=P_Ima^.Next;
     end;

     GetImgInfo:=P_Ima;
end;


function  GetMaxFrame(P_Ima: P_Images; which_sprite: word): word;
var  i     : word;
     P_Img : P_Image;
begin

     for i:=1 to which_sprite do
     begin
          if i=which_sprite then break;
          if P_Ima^.Next=nil then WriteExitMsg('Sprite not found.');
          P_Ima:=P_Ima^.Next;
     end;

     P_Img:=P_Ima^.image;

     i:=0;
     repeat
          inc(i);
          if P_Img^.Next=nil then break;
          P_Img:=P_Img^.Next;
     until false;

     GetMaxFrame:=i;
end;



function GetShipPos(Epi: P_Episodes; which_epi,which_lev,which_shi: word): P_ShipsPos;
var  P_Lev : P_Levels;
     P_Shi : P_ShipsPos;
     i     : word;
begin

     for i:=1 to which_epi do
     begin
          if i=which_epi then break;
          Epi:=Epi^.Next;
          if Epi = nil then break;
     end;

     P_Lev:=Epi^.Levels;
     if p_lev=nil then writeexitmsg('Level branche in episode have NULL assignment.');

     for i:=1 to which_lev do
     begin
          if i=which_lev then break;
          P_Lev:=P_Lev^.Next;
          if P_Lev = nil then WriteExitMsg('Wanted level DO NOT exists.');
     end;

     P_Shi:=P_Lev^.ShipsPos;
     if p_shi=nil then writeexitmsg('Ships positions in level have NULL assignment.');

     for i:=1 to which_shi do
     begin
           if i=which_shi then break;
           P_Shi:=P_Shi^.Next;
           if P_Shi = nil then WriteExitMsg('Wanted ship position DO NOT exists.');
     end;

     GetShipPos:=P_Shi;
end;


procedure DisposeShipPos(Epi: P_Episodes; which_epi,which_lev,which_shi: word);
var  P_Lev : P_Levels;
     P_Shi : P_ShipsPos;
     i     : word;
begin

     for i:=1 to which_epi do
     begin
          if i=which_epi then break;
          Epi:=Epi^.Next;
          if Epi = nil then break;
     end;

     P_Lev:=Epi^.Levels;
     if p_lev=nil then writeexitmsg('Level branche in episode have NULL assignment.');

     for i:=1 to which_lev do
     begin
          if i=which_lev then break;
          P_Lev:=P_Lev^.Next;
          if P_Lev = nil then WriteExitMsg('Wanted level DO NOT exists.');
     end;

     P_Shi:=P_Lev^.ShipsPos;
     if p_shi=nil then writeexitmsg('Ships positions in level have NULL assignment.');

     if which_shi=1 then
        begin
             freem(P_Lev^.ShipsPos,sizeof(t_shipspos));
             P_Lev^.ShipsPos:=nil;
        end else
     for i:=1 to which_shi do
     begin
           if i+1=which_shi then
              begin
                   freem(P_Shi^.Next,sizeof(t_shipspos));
                   P_Shi^.Next:=nil;
                   break;
              end;
           p_shi:=p_shi^.next;
           if P_Shi = nil then WriteExitMsg('Wanted ship position DO NOT exists.');
     end;
end;


procedure DisposeIntro(var p_int: p_intro);
var  p: pointer;
begin
     if p_int <> nil then            { Zwolnienie intra }
     begin
           p:=p_int;
           freem(P_Intro(p)^.text,P_Intro(p)^.size);

           p:=p_int^.image;
           if p_int^.image^.img.pal_exist then
           freem(p_image(p)^.img.pal,3*256);

           p:=p_int^.image;
           freem(p_image(p)^.img.data,p_image(p)^.img.size);

           p:=p_int^.image;
           freem(p,sizeof(t_image));

           p:=p_int;
           freem(p,sizeof(T_Intro));
           p_int:=nil;
     end;
end;


procedure DisposeLevel(var P_Lev: P_Levels);
var  p_shi : P_ShipsPos;
     p     : P_ShipsPos;
begin
     p_shi:=P_Lev^.ShipsPos;
     repeat
           p:=p_shi;
           p_shi:=p_shi^.next;
           if p<>nil then begin dispose(p); break; end;
{           freem(p,sizeof(T_ShipsPos));}
           if p_shi = nil then break;
     until false;

     DisposeIntro(P_Lev^.Intro);
     dispose(p_lev);
{     freem(p_lev,sizeof(t_levels));}
     p_lev:=nil;
end;


procedure DisposeAllLevels(var P_Lev: P_Levels);
var  p_shi  : P_ShipsPos;
     p_next : P_Levels;
     p      : pointer;
begin
     p_next:=p_lev;
     if p_next=nil then WriteExitMSG('kurwama.');
     repeat
     p_shi:=P_next^.ShipsPos;
     repeat
           p:=p_shi;
           freem(p,sizeof(T_ShipsPos));
           if p_shi^.next = nil then break;
           p_shi:=p_shi^.next;
     until false;


     DisposeIntro(P_next^.Intro);
     p:=p_next;
     p_next:=p_next^.next;
     freem(p,sizeof(t_levels));
     until p_next=nil;

     p_lev:=nil;
end;


function LastShipPos(Epi: P_Episodes; var which_epi,which_lev: word): P_ShipsPos;
var  P_Epi     : P_Episodes;
     P_Epi_tym : P_Episodes;
     P_Lev     : P_Levels;
     P_Lev_tym : P_Levels;
     P_Shi     : P_ShipsPos;
     P_Shi_tym : P_ShipsPos;
     i,tym     : word;
begin

     if epi=nil then WriteExitMsg('Episode link have null assignment.');

if which_epi=1 then P_Epi:=Epi;
if which_epi>1 then
begin
     P_Epi_Tym:=Epi;
     P_Epi:=Epi^.Next;

     For i:=1 to which_epi-1 do
     begin
          if P_Epi=nil then
             begin
                  P_Epi_Tym^.Next:=reserve_mem(sizeof(t_episodes));
                  P_Epi:=P_Epi_Tym^.Next;
                  P_Epi^.Levels:=nil;
                  P_Epi^.Next:=nil;
                  break;
             end;
          if i=which_epi-1 then break;
          P_Epi:=P_Epi^.Next;
          P_Epi_Tym:=P_Epi_Tym^.Next;
     end;
end;

     if P_epi^.Levels=nil then
        begin
             P_epi^.Levels:=reserve_mem(sizeof(t_levels));
             P_Lev:=P_Epi^.Levels;
             P_Lev^.next:=nil;
             P_lev^.shipspos:=nil;
        end;

if which_lev=1 then P_Lev:=P_Epi^.Levels;
if which_lev>1 then
begin
     P_lev_Tym:=p_Epi^.levels;
     P_lev:=P_Epi^.levels^.Next;

     For i:=1 to which_lev-1 do
     begin
          if P_Lev=nil then
             begin
                  P_lev_Tym^.Next:=reserve_mem(sizeof(t_levels));
                  P_lev:=P_lev_Tym^.Next;
                  P_Lev^.next:=nil;
                  P_lev^.shipspos:=nil;
                  break;
             end;
          if i=which_lev-1 then break;
          P_Lev:=P_Lev^.Next;
          P_Lev_Tym:=P_Lev_Tym^.Next;
     end;
end;

     if P_Lev^.Shipspos=nil then
        begin
             P_Lev^.Shipspos:=reserve_mem(sizeof(t_shipspos));
             P_Shi:=P_Lev^.shipspos;
             P_Shi^.next:=nil;
        end else
begin
     P_Shi_Tym:=p_lev^.shipspos;
     P_Shi:=P_lev^.shipspos^.Next;
     repeat
          if P_Shi=nil then
             begin
                  P_Shi_Tym^.Next:=reserve_mem(sizeof(t_shipspos));
                  P_Shi:=P_Shi_Tym^.Next;
                  P_Shi^.next:=nil;
                  break;
             end;
          P_Shi:=P_Shi^.Next;
          P_Shi_Tym:=P_Shi_Tym^.Next;
     until false;
end;

     LastShipPos:=P_Shi;
end;

function GetEpisodePoint(Epi: P_Episodes; which_epi: word): P_Episodes;
var  i   : word;
begin
     for i:=1 to which_epi do
     begin
          if i=which_epi then break;
          Epi:=Epi^.Next;
          if Epi = nil then break;
     end;

     GetEpisodePoint:=Epi;
end;


procedure Reserve4Episode(Epi: P_Episodes; which_epi: word);
var  i   : word;
begin
     for i:=1 to which_epi do
     begin
          if i=which_epi then break;
          if Epi^.next = nil then break;
          Epi:=Epi^.Next;
     end;

     Epi^.next:=reserve_mem(sizeof(t_episodes));
end;


function GetLevelPoint(Epi: P_Episodes; which_epi,which_lev: word): P_Levels;
var  P_Lev     : P_Levels;
     i         : word;
begin
     P_Lev:=GetEpisodePoint(Epi,which_epi)^.Levels;
     if p_lev=nil then
        begin
             GetLevelPoint:=nil;
             exit;
        end;

     for i:=1 to which_lev do
     begin
          if i=which_lev then break;
          P_Lev:=P_Lev^.Next;
          if P_Lev = nil then break;
     end;
     GetLevelPoint:=P_Lev;
end;

procedure Reserve4level(Epi: P_Episodes; which_epi,which_lev: word);
var  P_Lev     : P_Levels;
     i         : word;
begin
     P_Lev:=GetEpisodePoint(Epi,which_epi)^.Levels;
     if p_lev=nil then
        begin
             GetEpisodePoint(Epi,which_epi)^.Levels:=reserve_mem(sizeof(t_levels));
             exit;
        end;

     for i:=1 to which_lev do
     begin
          if i=which_lev then break;
          if P_Lev^.Next = nil then break;
          P_Lev:=P_Lev^.Next;
     end;
     p_lev^.next:=reserve_mem(sizeof(t_levels));
end;



end.